#!/usr/local/bin/wish -f
# Program: bongo
# Tcl version: 7.3 (Tcl/Tk/XF)
# Tk version: 3.6
# XF version: 2.2
#

# module inclusion
global env
global xfLoadPath
global xfLoadInfo
set xfLoadInfo 0
if {[info exists env(XF_LOAD_PATH)]} {
  if {[string first $env(XF_LOAD_PATH) ./:/usr/local/lib/] == -1} {
    set xfLoadPath $env(XF_LOAD_PATH):./:/usr/local/lib/
  } {
    set xfLoadPath ./:/usr/local/lib/
  }
} {
  set xfLoadPath ./:/usr/local/lib/
}

global argc
global argv
global tkVersion
set tmpArgv ""
for {set counter 0} {$counter < $argc} {incr counter 1} {
  case [string tolower [lindex $argv $counter]] in {
    {-xfloadpath} {
      incr counter 1
      set xfLoadPath "[lindex $argv $counter]:$xfLoadPath"
    }
    {-xfstartup} {
      incr counter 1
      source [lindex $argv $counter]
    }
    {-xfbindfile} {
      incr counter 1
      set env(XF_BIND_FILE) "[lindex $argv $counter]"
    }
    {-xfcolorfile} {
      incr counter 1
      set env(XF_COLOR_FILE) "[lindex $argv $counter]"
    }
    {-xfcursorfile} {
      incr counter 1
      set env(XF_CURSOR_FILE) "[lindex $argv $counter]"
    }
    {-xffontfile} {
      incr counter 1
      set env(XF_FONT_FILE) "[lindex $argv $counter]"
    }
    {-xfmodelmono} {
      if {$tkVersion >= 3.0} {
        tk colormodel . monochrome
      }
    }
    {-xfmodelcolor} {
      if {$tkVersion >= 3.0} {
        tk colormodel . color
      }
    }
    {-xfloading} {
      set xfLoadInfo 1
    }
    {-xfnoloading} {
      set xfLoadInfo 0
    }
    {default} {
      lappend tmpArgv [lindex $argv $counter]
    }
  }
}
set argv $tmpArgv
set argc [llength $tmpArgv]
unset counter
unset tmpArgv


# procedure to show window .
proc ShowWindow. {args} {# xf ignore me 7

  # Window manager configurations
  global tkVersion
  wm positionfrom . user
  wm sizefrom . user
  wm maxsize . 1152 900
  wm title . {Bongo 0.0}


  # build widget .frame0
  frame .frame0 \
    -borderwidth {2} \
    -relief {raised}

  # build widget .frame0.frame0
  frame .frame0.frame0 \
    -borderwidth {2} \
    -relief {raised}

  # build widget .frame0.frame0.menubutton1
  menubutton .frame0.frame0.menubutton1 \
    -menu {.frame0.frame0.menubutton1.m} \
    -text {File} \
    -underline {0}

  # build widget .frame0.frame0.menubutton1.m
  menu .frame0.frame0.menubutton1.m
  .frame0.frame0.menubutton1.m add command \
    -command {exit 0} \
    -label {Quit}

  # build widget .frame0.frame0.menubutton2
  menubutton .frame0.frame0.menubutton2 \
    -menu {.frame0.frame0.menubutton2.m} \
    -text {Help} \
    -underline {0}

  # build widget .frame0.frame0.menubutton2.m
  menu .frame0.frame0.menubutton2.m
  .frame0.frame0.menubutton2.m add command \
    -command {YesNoBox {Don't take any wooden nickels}} \
    -label {Advice} \
    -state {active}

  # pack widget .frame0.frame0
  pack append .frame0.frame0 \
    .frame0.frame0.menubutton1 {left frame center} \
    .frame0.frame0.menubutton2 {right frame center}

  # pack widget .frame0
  pack append .frame0 \
    .frame0.frame0 {top frame center fillx}

  # build widget .frame1
  frame .frame1 \
    -borderwidth {2}

  # build widget .frame1.frame2
  frame .frame1.frame2 \
    -borderwidth {1}

  # build widget .frame1.frame2.frame0
  frame .frame1.frame2.frame0 \
    -borderwidth {5} \
    -relief {groove}

  # build widget .frame1.frame2.frame0.frame3
  frame .frame1.frame2.frame0.frame3 \
    -background {#d3e499} \
    -borderwidth {2} \
    -relief {groove}

  # build widget .frame1.frame2.frame0.frame3.frame10
  frame .frame1.frame2.frame0.frame3.frame10 \
    -borderwidth {2} \
    -relief {groove}

  # build widget .frame1.frame2.frame0.frame3.frame10.button48
  button .frame1.frame2.frame0.frame3.frame10.button48 \
    -command {tester "$vl_options_1"} \
    -text {LIST}

  # pack widget .frame1.frame2.frame0.frame3.frame10
  pack append .frame1.frame2.frame0.frame3.frame10 \
    .frame1.frame2.frame0.frame3.frame10.button48 {top frame center fillx}

  # build widget .frame1.frame2.frame0.frame3.frame11
  frame .frame1.frame2.frame0.frame3.frame11 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame28
  frame .frame1.frame2.frame0.frame3.frame11.frame28 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton32
  radiobutton .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton32 \
    -text {} \
    -value {vl -al} \
    -variable {vl_options_1}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton33
  radiobutton .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton33 \
    -text {} \
    -value {vl -al -locked} \
    -variable {vl_options_1}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton49
  radiobutton .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton49 \
    -text {} \
    -value {vl -al -cache} \
    -variable {vl_options_1}

  # pack widget .frame1.frame2.frame0.frame3.frame11.frame28
  pack append .frame1.frame2.frame0.frame3.frame11.frame28 \
    .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton32 {top frame w fillx} \
    .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton33 {top frame w fillx} \
    .frame1.frame2.frame0.frame3.frame11.frame28.radiobutton49 {top frame center fillx}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame37
  frame .frame1.frame2.frame0.frame3.frame11.frame37 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame37.label40
  label .frame1.frame2.frame0.frame3.frame11.frame37.label40 \
    -text {ALL}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame37.label41
  label .frame1.frame2.frame0.frame3.frame11.frame37.label41 \
    -text {LOCKED}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame37.label50
  label .frame1.frame2.frame0.frame3.frame11.frame37.label50 \
    -text {CACHE}

  # pack widget .frame1.frame2.frame0.frame3.frame11.frame37
  pack append .frame1.frame2.frame0.frame3.frame11.frame37 \
    .frame1.frame2.frame0.frame3.frame11.frame37.label40 {top frame w} \
    .frame1.frame2.frame0.frame3.frame11.frame37.label41 {top frame w} \
    .frame1.frame2.frame0.frame3.frame11.frame37.label50 {top frame w}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame38
  frame .frame1.frame2.frame0.frame3.frame11.frame38 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton45
  radiobutton .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton45 \
    -text {} \
    -value {vl -al -attr "status=busy"} \
    -variable {vl_options_1}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton46
  radiobutton .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton46 \
    -text {} \
    -value {vl -al -last} \
    -variable {vl_options_1}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton47
  radiobutton .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton47 \
    -text {} \
    -value {vl -al -attr "status=saved"} \
    -variable {vl_options_1}

  # pack widget .frame1.frame2.frame0.frame3.frame11.frame38
  pack append .frame1.frame2.frame0.frame3.frame11.frame38 \
    .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton45 {top frame center} \
    .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton46 {top frame center} \
    .frame1.frame2.frame0.frame3.frame11.frame38.radiobutton47 {top frame center}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame39
  frame .frame1.frame2.frame0.frame3.frame11.frame39 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame39.label42
  label .frame1.frame2.frame0.frame3.frame11.frame39.label42 \
    -text {BUSY}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame39.label43
  label .frame1.frame2.frame0.frame3.frame11.frame39.label43 \
    -text {LATEST}

  # build widget .frame1.frame2.frame0.frame3.frame11.frame39.label44
  label .frame1.frame2.frame0.frame3.frame11.frame39.label44 \
    -text {SAVED}

  # pack widget .frame1.frame2.frame0.frame3.frame11.frame39
  pack append .frame1.frame2.frame0.frame3.frame11.frame39 \
    .frame1.frame2.frame0.frame3.frame11.frame39.label42 {top frame w} \
    .frame1.frame2.frame0.frame3.frame11.frame39.label43 {top frame w} \
    .frame1.frame2.frame0.frame3.frame11.frame39.label44 {top frame w}

  # pack widget .frame1.frame2.frame0.frame3.frame11
  pack append .frame1.frame2.frame0.frame3.frame11 \
    .frame1.frame2.frame0.frame3.frame11.frame28 {left frame w expand fill} \
    .frame1.frame2.frame0.frame3.frame11.frame37 {left frame center expand fill} \
    .frame1.frame2.frame0.frame3.frame11.frame38 {left frame center expand fill} \
    .frame1.frame2.frame0.frame3.frame11.frame39 {left frame center expand fill}

  # build widget .frame1.frame2.frame0.frame3.frame12
  frame .frame1.frame2.frame0.frame3.frame12 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame3.frame12.frame
  frame .frame1.frame2.frame0.frame3.frame12.frame

  # build widget .frame1.frame2.frame0.frame3.frame12.frame.scrollbar1
  scrollbar .frame1.frame2.frame0.frame3.frame12.frame.scrollbar1 \
    -command {.frame1.frame2.frame0.frame3.frame12.frame.entry2 view} \
    -orient {horizontal} \
    -relief {raised} \
    -width {11}

  # build widget .frame1.frame2.frame0.frame3.frame12.frame.entry2
  entry .frame1.frame2.frame0.frame3.frame12.frame.entry2 \
    -background {#ffd8d2} \
    -relief {sunken} \
    -scrollcommand {.frame1.frame2.frame0.frame3.frame12.frame.scrollbar1 set} \
    -textvariable {vl_options_1}

  # pack widget .frame1.frame2.frame0.frame3.frame12.frame
  pack append .frame1.frame2.frame0.frame3.frame12.frame \
    .frame1.frame2.frame0.frame3.frame12.frame.entry2 {top frame center fill} \
    .frame1.frame2.frame0.frame3.frame12.frame.scrollbar1 {top frame center fillx}

  # pack widget .frame1.frame2.frame0.frame3.frame12
  pack append .frame1.frame2.frame0.frame3.frame12 \
    .frame1.frame2.frame0.frame3.frame12.frame {top frame center fill}

  # pack widget .frame1.frame2.frame0.frame3
  pack append .frame1.frame2.frame0.frame3 \
    .frame1.frame2.frame0.frame3.frame10 {top frame center fillx} \
    .frame1.frame2.frame0.frame3.frame11 {top frame center fillx} \
    .frame1.frame2.frame0.frame3.frame12 {top frame center fill}

  # build widget .frame1.frame2.frame0.frame4
  frame .frame1.frame2.frame0.frame4 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .frame1.frame2.frame0.frame4.frame0
  frame .frame1.frame2.frame0.frame4.frame0 \
    -borderwidth {2} \
    -relief {raised}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame8
  frame .frame1.frame2.frame0.frame4.frame0.frame8 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame8.button10
  button .frame1.frame2.frame0.frame4.frame0.frame8.button10 \
    -command {set message [InputBoxMulti {} {} {} {} {ShapeTool Check-Out Log Entry}]

set command_entry "retrv -l -m \"$message\" -f -q $attr(short_name)"
if $active_command {
    eval exec $command_entry
}} \
    -text {Check Out}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame8.button11
  button .frame1.frame2.frame0.frame4.frame0.frame8.button11 \
    -command {set command_entry "retrv -f -q $attr(short_name)"

if $active_command {
    eval exec $command_entry
}} \
    -text {Get Copy}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame8.button12
  button .frame1.frame2.frame0.frame4.frame0.frame8.button12 \
    -command {set command_entry "atfsrepair -C -q"

if $active_command {
   eval exec $command_entry
}} \
    -text {Clean Cache}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame8.radiobutton6
  radiobutton .frame1.frame2.frame0.frame4.frame0.frame8.radiobutton6 \
    -text {active} \
    -value {1} \
    -variable {active_command}

  # pack widget .frame1.frame2.frame0.frame4.frame0.frame8
  pack append .frame1.frame2.frame0.frame4.frame0.frame8 \
    .frame1.frame2.frame0.frame4.frame0.frame8.button10 {top frame center fillx} \
    .frame1.frame2.frame0.frame4.frame0.frame8.button11 {top frame center fillx} \
    .frame1.frame2.frame0.frame4.frame0.frame8.button12 {top frame center fillx} \
    .frame1.frame2.frame0.frame4.frame0.frame8.radiobutton6 {top frame center fillx}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame9
  frame .frame1.frame2.frame0.frame4.frame0.frame9 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame9.button13
  button .frame1.frame2.frame0.frame4.frame0.frame9.button13 \
    -command {set message [InputBoxMulti {} {} {} {} {ShapeTool Check-In Log Entry}]

set command_entry "save -m \"$message\" -q $attr(short_name)"

if $active_command {
   eval exec $command_entry
}} \
    -text {Check In}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame9.button14
  button .frame1.frame2.frame0.frame4.frame0.frame9.button14 \
    -text {}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame9.button15
  button .frame1.frame2.frame0.frame4.frame0.frame9.button15 \
    -text {}

  # build widget .frame1.frame2.frame0.frame4.frame0.frame9.radiobutton7
  radiobutton .frame1.frame2.frame0.frame4.frame0.frame9.radiobutton7 \
    -text {preview} \
    -value {0} \
    -variable {active_command}

  # pack widget .frame1.frame2.frame0.frame4.frame0.frame9
  pack append .frame1.frame2.frame0.frame4.frame0.frame9 \
    .frame1.frame2.frame0.frame4.frame0.frame9.button13 {top frame center fillx} \
    .frame1.frame2.frame0.frame4.frame0.frame9.button14 {top frame center fillx} \
    .frame1.frame2.frame0.frame4.frame0.frame9.button15 {top frame center fillx} \
    .frame1.frame2.frame0.frame4.frame0.frame9.radiobutton7 {top frame center fillx}

  # pack widget .frame1.frame2.frame0.frame4.frame0
  pack append .frame1.frame2.frame0.frame4.frame0 \
    .frame1.frame2.frame0.frame4.frame0.frame8 {left frame center expand fillx} \
    .frame1.frame2.frame0.frame4.frame0.frame9 {left frame center expand fillx}

  # build widget .frame1.frame2.frame0.frame4.frame
  frame .frame1.frame2.frame0.frame4.frame

  # build widget .frame1.frame2.frame0.frame4.frame.button8
  button .frame1.frame2.frame0.frame4.frame.button8 \
    -command {eval exec $command_entry} \
    -text {X}

  # build widget .frame1.frame2.frame0.frame4.frame.frame
  frame .frame1.frame2.frame0.frame4.frame.frame

  # build widget .frame1.frame2.frame0.frame4.frame.frame.scrollbar1
  scrollbar .frame1.frame2.frame0.frame4.frame.frame.scrollbar1 \
    -command {.frame1.frame2.frame0.frame4.frame.frame.entry2 view} \
    -orient {horizontal} \
    -relief {raised} \
    -width {11}

  # build widget .frame1.frame2.frame0.frame4.frame.frame.entry2
  entry .frame1.frame2.frame0.frame4.frame.frame.entry2 \
    -background {#ffd8d2} \
    -relief {sunken} \
    -scrollcommand {.frame1.frame2.frame0.frame4.frame.frame.scrollbar1 set} \
    -textvariable {command_entry}

  # pack widget .frame1.frame2.frame0.frame4.frame.frame
  pack append .frame1.frame2.frame0.frame4.frame.frame \
    .frame1.frame2.frame0.frame4.frame.frame.entry2 {top frame center fill} \
    .frame1.frame2.frame0.frame4.frame.frame.scrollbar1 {top frame center fillx}

  # pack widget .frame1.frame2.frame0.frame4.frame
  pack append .frame1.frame2.frame0.frame4.frame \
    .frame1.frame2.frame0.frame4.frame.button8 {right frame center filly} \
    .frame1.frame2.frame0.frame4.frame.frame {top frame center fill}

  # pack widget .frame1.frame2.frame0.frame4
  pack append .frame1.frame2.frame0.frame4 \
    .frame1.frame2.frame0.frame4.frame0 {top frame center expand fillx} \
    .frame1.frame2.frame0.frame4.frame {top frame center fill}

  # build widget .frame1.frame2.frame0.frame5
  frame .frame1.frame2.frame0.frame5 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .frame1.frame2.frame0.frame5.frame0
  frame .frame1.frame2.frame0.frame5.frame0 \
    -borderwidth {2} \
    -relief {raised}

  # build widget .frame1.frame2.frame0.frame5.frame0.button2
  button .frame1.frame2.frame0.frame5.frame0.button2 \
    -command {eval exec $apply_command} \
    -text {APPLY}

  # build widget .frame1.frame2.frame0.frame5.frame0.button3
  button .frame1.frame2.frame0.frame5.frame0.button3 \
    -command {apply} \
    -text {RESTORE}

  # pack widget .frame1.frame2.frame0.frame5.frame0
  pack append .frame1.frame2.frame0.frame5.frame0 \
    .frame1.frame2.frame0.frame5.frame0.button2 {left frame center expand fillx} \
    .frame1.frame2.frame0.frame5.frame0.button3 {left frame center expand fillx}

  # build widget .frame1.frame2.frame0.frame5.frame
  frame .frame1.frame2.frame0.frame5.frame

  # build widget .frame1.frame2.frame0.frame5.frame.scrollbar1
  scrollbar .frame1.frame2.frame0.frame5.frame.scrollbar1 \
    -command {.frame1.frame2.frame0.frame5.frame.entry2 view} \
    -orient {horizontal} \
    -relief {raised} \
    -width {11}

  # build widget .frame1.frame2.frame0.frame5.frame.entry2
  entry .frame1.frame2.frame0.frame5.frame.entry2 \
    -background {#ffd8d2} \
    -relief {sunken} \
    -scrollcommand {.frame1.frame2.frame0.frame5.frame.scrollbar1 set} \
    -textvariable {apply_command}

  # pack widget .frame1.frame2.frame0.frame5.frame
  pack append .frame1.frame2.frame0.frame5.frame \
    .frame1.frame2.frame0.frame5.frame.entry2 {top frame center fill} \
    .frame1.frame2.frame0.frame5.frame.scrollbar1 {top frame center fillx}

  # pack widget .frame1.frame2.frame0.frame5
  pack append .frame1.frame2.frame0.frame5 \
    .frame1.frame2.frame0.frame5.frame {bottom frame center fill} \
    .frame1.frame2.frame0.frame5.frame0 {top frame center fillx}

  # build widget .frame1.frame2.frame0.frame9
  frame .frame1.frame2.frame0.frame9 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .frame1.frame2.frame0.frame9.frame10
  frame .frame1.frame2.frame0.frame9.frame10 \
    -borderwidth {2}

  # build widget .frame1.frame2.frame0.frame9.frame10.button11
  button .frame1.frame2.frame0.frame9.frame10.button11 \
    -command {set dir_selection [FSBox]

if [IsADir $dir_selection] { set working_dir $dir_selection } {  AlertBox "your selection:\n$dir_selection\nis a  file\nTry again with a Directory" {} {350x150} {Not A DIRECTORY} }

cd $working_dir} \
    -text {Change Working Directory}

  # build widget .frame1.frame2.frame0.frame9.frame10.frame
  frame .frame1.frame2.frame0.frame9.frame10.frame \
    -relief {sunken}

  # build widget .frame1.frame2.frame0.frame9.frame10.frame.scrollbar1
  scrollbar .frame1.frame2.frame0.frame9.frame10.frame.scrollbar1 \
    -command {.frame1.frame2.frame0.frame9.frame10.frame.entry2 view} \
    -orient {horizontal} \
    -relief {raised} \
    -width {11}

  # build widget .frame1.frame2.frame0.frame9.frame10.frame.entry2
  entry .frame1.frame2.frame0.frame9.frame10.frame.entry2 \
    -background {#ffd8d2} \
    -relief {sunken} \
    -scrollcommand {.frame1.frame2.frame0.frame9.frame10.frame.scrollbar1 set} \
    -textvariable {working_dir}

  # pack widget .frame1.frame2.frame0.frame9.frame10.frame
  pack append .frame1.frame2.frame0.frame9.frame10.frame \
    .frame1.frame2.frame0.frame9.frame10.frame.entry2 {top frame center fill} \
    .frame1.frame2.frame0.frame9.frame10.frame.scrollbar1 {top frame center fillx}

  # pack widget .frame1.frame2.frame0.frame9.frame10
  pack append .frame1.frame2.frame0.frame9.frame10 \
    .frame1.frame2.frame0.frame9.frame10.button11 {top frame center fillx} \
    .frame1.frame2.frame0.frame9.frame10.frame {top frame center fill}

  # pack widget .frame1.frame2.frame0.frame9
  pack append .frame1.frame2.frame0.frame9 \
    .frame1.frame2.frame0.frame9.frame10 {top frame center expand fill}

  # pack widget .frame1.frame2.frame0
  pack append .frame1.frame2.frame0 \
    .frame1.frame2.frame0.frame3 {top frame center expand fillx} \
    .frame1.frame2.frame0.frame4 {top frame center expand fillx} \
    .frame1.frame2.frame0.frame5 {bottom frame center expand fillx} \
    .frame1.frame2.frame0.frame9 {top frame center expand fillx}

  # pack widget .frame1.frame2
  pack append .frame1.frame2 \
    .frame1.frame2.frame0 {top frame center expand fill}

  # build widget .frame1.frame
  frame .frame1.frame

  # build widget .frame1.frame.scrollbar3
  scrollbar .frame1.frame.scrollbar3 \
    -command {.frame1.frame.listbox1 xview} \
    -orient {horizontal} \
    -relief {raised}

  # build widget .frame1.frame.scrollbar2
  scrollbar .frame1.frame.scrollbar2 \
    -command {.frame1.frame.listbox1 yview} \
    -relief {raised}

  # build widget .frame1.frame.listbox1
  listbox .frame1.frame.listbox1 \
    -background {#ffd8d2} \
    -font {7x14} \
    -relief {sunken} \
    -xscrollcommand {.frame1.frame.scrollbar3 set} \
    -yscrollcommand {.frame1.frame.scrollbar2 set}
  # bindings
  bind .frame1.frame.listbox1 <Double-Button-1> {new_object_selected
set apply_command {}}

  # pack widget .frame1.frame
  pack append .frame1.frame \
    .frame1.frame.scrollbar2 {left frame center filly} \
    .frame1.frame.listbox1 {top frame center expand fill} \
    .frame1.frame.scrollbar3 {bottom frame center fillx}

  # build widget .frame1.frame0
  frame .frame1.frame0 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .frame1.frame0.frame1
  frame .frame1.frame0.frame1 \
    -borderwidth {2}

  # build widget .frame1.frame0.frame1.frame
  frame .frame1.frame0.frame1.frame \
    -relief {raised}

  # build widget .frame1.frame0.frame1.frame.label4
  label .frame1.frame0.frame1.frame.label4 \
    -padx {2} \
    -text {Object Name:}

  # build widget .frame1.frame0.frame1.frame.label1
  label .frame1.frame0.frame1.frame.label1 \
    -relief {groove} \
    -text {tester1.c}

  # pack widget .frame1.frame0.frame1.frame
  pack append .frame1.frame0.frame1.frame \
    .frame1.frame0.frame1.frame.label4 {left frame center} \
    .frame1.frame0.frame1.frame.label1 {left frame center expand fillx}

  # build widget .frame1.frame0.frame1.frame0
  frame .frame1.frame0.frame1.frame0 \
    -borderwidth {2}

  # build widget .frame1.frame0.frame1.frame0.label1
  label .frame1.frame0.frame1.frame0.label1 \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Owner: }

  # build widget .frame1.frame0.frame1.frame0.value
  entry .frame1.frame0.frame1.frame0.value \
    -relief {sunken}

  # build widget .frame1.frame0.frame1.frame0.menubutton2
  menubutton .frame1.frame0.frame1.frame0.menubutton2 \
    -menu {.frame1.frame0.frame1.frame0.menubutton2.m} \
    -text {v}

  # build widget .frame1.frame0.frame1.frame0.menubutton2.m
  menu .frame1.frame0.frame1.frame0.menubutton2.m
  .frame1.frame0.frame1.frame0.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame0} \
    -label {gac}
  .frame1.frame0.frame1.frame0.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame0} \
    -label {tesundst}
  .frame1.frame0.frame1.frame0.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame0}
  .frame1.frame0.frame1.frame0.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame0} \
    -label {root}
  .frame1.frame0.frame1.frame0.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame0} \
    -label {madderra}

  # pack widget .frame1.frame0.frame1.frame0
  pack append .frame1.frame0.frame1.frame0 \
    .frame1.frame0.frame1.frame0.label1 {left frame center fill} \
    .frame1.frame0.frame1.frame0.value {left frame center expand fill} \
    .frame1.frame0.frame1.frame0.menubutton2 {right frame center fill}

  # build widget .frame1.frame0.frame1.frame15
  frame .frame1.frame0.frame1.frame15 \
    -borderwidth {2}

  # build widget .frame1.frame0.frame1.frame15.label1
  label .frame1.frame0.frame1.frame15.label1 \
    -borderwidth {0} \
    -text {Host: }

  # build widget .frame1.frame0.frame1.frame15.value
  entry .frame1.frame0.frame1.frame15.value \
    -relief {sunken}

  # build widget .frame1.frame0.frame1.frame15.menubutton2
  menubutton .frame1.frame0.frame1.frame15.menubutton2 \
    -menu {.frame1.frame0.frame1.frame15.menubutton2.m} \
    -text {v}

  # build widget .frame1.frame0.frame1.frame15.menubutton2.m
  menu .frame1.frame0.frame1.frame15.menubutton2.m
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {emsdev6}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {emsdev7}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {gomez}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {chernobyl}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {jms}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {caj}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {lyt}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {ejm}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {TinMan}
  .frame1.frame0.frame1.frame15.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame15} \
    -label {zeus}

  # pack widget .frame1.frame0.frame1.frame15
  pack append .frame1.frame0.frame1.frame15 \
    .frame1.frame0.frame1.frame15.label1 {left frame center fill} \
    .frame1.frame0.frame1.frame15.value {left frame center expand fill} \
    .frame1.frame0.frame1.frame15.menubutton2 {right frame center fill}

  # build widget .frame1.frame0.frame1.frame16
  frame .frame1.frame0.frame1.frame16 \
    -borderwidth {2}

  # build widget .frame1.frame0.frame1.frame16.label1
  label .frame1.frame0.frame1.frame16.label1 \
    -borderwidth {0} \
    -relief {ridge} \
    -text {Author: }

  # build widget .frame1.frame0.frame1.frame16.value
  entry .frame1.frame0.frame1.frame16.value \
    -relief {sunken}

  # build widget .frame1.frame0.frame1.frame16.menubutton2
  menubutton .frame1.frame0.frame1.frame16.menubutton2 \
    -menu {.frame1.frame0.frame1.frame16.menubutton2.m} \
    -text {v}

  # build widget .frame1.frame0.frame1.frame16.menubutton2.m
  menu .frame1.frame0.frame1.frame16.menubutton2.m
  .frame1.frame0.frame1.frame16.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame16} \
    -label {gac}
  .frame1.frame0.frame1.frame16.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame16} \
    -label {tesundst}
  .frame1.frame0.frame1.frame16.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame16}
  .frame1.frame0.frame1.frame16.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame16} \
    -label {root}
  .frame1.frame0.frame1.frame16.menubutton2.m add command \
    -command {OptionButtonSet .frame1.frame0.frame1.frame16} \
    -label {madderra}

  # pack widget .frame1.frame0.frame1.frame16
  pack append .frame1.frame0.frame1.frame16 \
    .frame1.frame0.frame1.frame16.label1 {left frame center fill} \
    .frame1.frame0.frame1.frame16.value {left frame center expand fill} \
    .frame1.frame0.frame1.frame16.menubutton2 {right frame center fill}

  # pack widget .frame1.frame0.frame1
  pack append .frame1.frame0.frame1 \
    .frame1.frame0.frame1.frame {top frame center fill} \
    .frame1.frame0.frame1.frame0 {top frame center fillx} \
    .frame1.frame0.frame1.frame15 {top frame center fillx} \
    .frame1.frame0.frame1.frame16 {top frame center fillx}

  # build widget .frame1.frame0.frame2
  frame .frame1.frame0.frame2 \
    -borderwidth {2}

  # build widget .frame1.frame0.frame2.frame7
  frame .frame1.frame0.frame2.frame7 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .frame1.frame0.frame2.frame7.label11
  label .frame1.frame0.frame2.frame7.label11 \
    -relief {ridge} \
    -text {}

  # build widget .frame1.frame0.frame2.frame7.checkbutton12
  checkbutton .frame1.frame0.frame2.frame7.checkbutton12 \
    -command {if ($locker_bit) {
  regexp {^[ ]*([^ ]+) } [exec who am i] null whoami
  set attr(locker) "$whoami@[exec uname -n]"
  [SymbolicName obj_locker] configure -text $attr(locker)
} {
  set attr(locker) {}
  [SymbolicName obj_locker] configure -text $attr(locker)
}
apply} \
    -text {} \
    -variable {locker_bit}

  # build widget .frame1.frame0.frame2.frame7.label27
  label .frame1.frame0.frame2.frame7.label27 \
    -text {Locker:}

  # pack widget .frame1.frame0.frame2.frame7
  pack append .frame1.frame0.frame2.frame7 \
    .frame1.frame0.frame2.frame7.label27 {left frame center fillx} \
    .frame1.frame0.frame2.frame7.label11 {left frame w expand fillx} \
    .frame1.frame0.frame2.frame7.checkbutton12 {right frame e}

  # build widget .frame1.frame0.frame2.frame8
  frame .frame1.frame0.frame2.frame8 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .frame1.frame0.frame2.frame8.label15
  label .frame1.frame0.frame2.frame8.label15 \
    -text {user mode:}

  # build widget .frame1.frame0.frame2.frame8.checkbutton16
  checkbutton .frame1.frame0.frame2.frame8.checkbutton16 \
    -command {apply} \
    -text {r} \
    -variable {mode(u,r)}

  # build widget .frame1.frame0.frame2.frame8.checkbutton17
  checkbutton .frame1.frame0.frame2.frame8.checkbutton17 \
    -command {apply} \
    -text {w} \
    -variable {mode(u,w)}

  # build widget .frame1.frame0.frame2.frame8.checkbutton18
  checkbutton .frame1.frame0.frame2.frame8.checkbutton18 \
    -command {apply} \
    -text {x} \
    -variable {mode(u,x)}

  # pack widget .frame1.frame0.frame2.frame8
  pack append .frame1.frame0.frame2.frame8 \
    .frame1.frame0.frame2.frame8.label15 {left frame w expand} \
    .frame1.frame0.frame2.frame8.checkbutton16 {left frame center} \
    .frame1.frame0.frame2.frame8.checkbutton17 {left frame center} \
    .frame1.frame0.frame2.frame8.checkbutton18 {left frame center}

  # build widget .frame1.frame0.frame2.frame9
  frame .frame1.frame0.frame2.frame9 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .frame1.frame0.frame2.frame9.label19
  label .frame1.frame0.frame2.frame9.label19 \
    -text {group mode:}

  # build widget .frame1.frame0.frame2.frame9.checkbutton20
  checkbutton .frame1.frame0.frame2.frame9.checkbutton20 \
    -command {apply} \
    -text {r} \
    -variable {mode(g,r)}

  # build widget .frame1.frame0.frame2.frame9.checkbutton21
  checkbutton .frame1.frame0.frame2.frame9.checkbutton21 \
    -command {apply} \
    -text {w} \
    -variable {mode(g,w)}

  # build widget .frame1.frame0.frame2.frame9.checkbutton22
  checkbutton .frame1.frame0.frame2.frame9.checkbutton22 \
    -command {apply} \
    -text {x} \
    -variable {mode(g,x)}

  # pack widget .frame1.frame0.frame2.frame9
  pack append .frame1.frame0.frame2.frame9 \
    .frame1.frame0.frame2.frame9.label19 {left frame w expand} \
    .frame1.frame0.frame2.frame9.checkbutton20 {left frame center} \
    .frame1.frame0.frame2.frame9.checkbutton21 {left frame center} \
    .frame1.frame0.frame2.frame9.checkbutton22 {left frame center}

  # build widget .frame1.frame0.frame2.frame10
  frame .frame1.frame0.frame2.frame10 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .frame1.frame0.frame2.frame10.label23
  label .frame1.frame0.frame2.frame10.label23 \
    -text {all mode:}

  # build widget .frame1.frame0.frame2.frame10.checkbutton24
  checkbutton .frame1.frame0.frame2.frame10.checkbutton24 \
    -command {apply} \
    -text {r} \
    -variable {mode(a,r)}

  # build widget .frame1.frame0.frame2.frame10.checkbutton25
  checkbutton .frame1.frame0.frame2.frame10.checkbutton25 \
    -command {apply} \
    -text {w} \
    -variable {mode(a,w)}

  # build widget .frame1.frame0.frame2.frame10.checkbutton26
  checkbutton .frame1.frame0.frame2.frame10.checkbutton26 \
    -command {apply} \
    -text {x} \
    -variable {mode(a,x)}

  # pack widget .frame1.frame0.frame2.frame10
  pack append .frame1.frame0.frame2.frame10 \
    .frame1.frame0.frame2.frame10.label23 {left frame w expand} \
    .frame1.frame0.frame2.frame10.checkbutton24 {left frame center} \
    .frame1.frame0.frame2.frame10.checkbutton25 {left frame center} \
    .frame1.frame0.frame2.frame10.checkbutton26 {left frame center}

  # pack widget .frame1.frame0.frame2
  pack append .frame1.frame0.frame2 \
    .frame1.frame0.frame2.frame7 {top frame center fillx} \
    .frame1.frame0.frame2.frame8 {top frame center fillx} \
    .frame1.frame0.frame2.frame9 {top frame center fillx} \
    .frame1.frame0.frame2.frame10 {top frame center expand fillx}

  # pack widget .frame1.frame0
  pack append .frame1.frame0 \
    .frame1.frame0.frame1 {left frame center expand fillx} \
    .frame1.frame0.frame2 {right frame center expand fill}

  # pack widget .frame1
  pack append .frame1 \
    .frame1.frame2 {right frame center filly} \
    .frame1.frame {top frame n expand fill} \
    .frame1.frame0 {left frame s expand fill}

  # pack widget .
  pack append . \
    .frame0 {top frame center fill} \
    .frame1 {top frame center expand fill}

  global tkVersion
  if {$tkVersion >= 3.0} {
    tk_menuBar .frame0.frame0 .frame0.frame0.menubutton1 .frame0.frame0.menubutton2
  } {
    tk_menus . .frame0.frame0.menubutton1 .frame0.frame0.menubutton2
  }

  .frame1.frame.listbox1 insert end {}
  .frame1.frame0.frame1.frame0.value insert end {  double click on a file (after listing)}
  .frame1.frame0.frame1.frame15.value insert end {}
  .frame1.frame0.frame1.frame16.value insert end {}



  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree ."
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# User defined procedures


# Procedure: AlertBox
proc AlertBox { {alertBoxMessage "Alert message"} {alertBoxCommand ""} {alertBoxGeometry "350x150"} {alertBoxTitle "Alert box"} args} {
# xf ignore me 5
##########
# Procedure: AlertBox
# Description: show alert box
# Arguments: {alertBoxMessage} - the text to display
#            {alertBoxCommand} - the command to call after ok
#            {alertBoxGeometry} - the geometry for the window
#            {alertBoxTitle} - the title for the window
#            {args} - labels of buttons
# Returns: The number of the selected button, ot nothing
# Sideeffects: none
# Notes: there exist also functions called:
#          AlertBoxFile - to open and read a file automatically
#          AlertBoxFd - to read from an already opened filedescriptor
##########
#
# global alertBox(activeBackground) - active background color
# global alertBox(activeForeground) - active foreground color
# global alertBox(after) - destroy alert box after n seconds
# global alertBox(anchor) - anchor for message box
# global alertBox(background) - background color
# global alertBox(font) - message font
# global alertBox(foreground) - foreground color
# global alertBox(justify) - justify for message box
# global alertBox(toplevelName) - the toplevel name

  global alertBox

  # show alert box
  if {[llength $args] > 0} {
    eval AlertBoxInternal "\{$alertBoxMessage\}" "\{$alertBoxCommand\}" "\{$alertBoxGeometry\}" "\{$alertBoxTitle\}" $args
  } {
    AlertBoxInternal $alertBoxMessage $alertBoxCommand $alertBoxGeometry $alertBoxTitle
  }

  if {[llength $args] > 0} {
    # wait for the box to be destroyed
    update idletask
    grab $alertBox(toplevelName)
    tkwait window $alertBox(toplevelName)

    return $alertBox(button)
  }
}


# Procedure: AlertBoxFd
proc AlertBoxFd { {alertBoxInFile ""} {alertBoxCommand ""} {alertBoxGeometry "350x150"} {alertBoxTitle "Alert box"} args} {
# xf ignore me 5
##########
# Procedure: AlertBoxFd
# Description: show alert box containing a filedescriptor
# Arguments: {alertBoxInFile} - a filedescriptor to read. The descriptor
#                               is closed after reading
#            {alertBoxCommand} - the command to call after ok
#            {alertBoxGeometry} - the geometry for the window
#            {alertBoxTitle} - the title for the window
#            {args} - labels of buttons
# Returns: The number of the selected button, ot nothing
# Sideeffects: none
# Notes: there exist also functions called:
#          AlertBox - to display a passed string
#          AlertBoxFile - to open and read a file automatically
##########
#
# global alertBox(activeBackground) - active background color
# global alertBox(activeForeground) - active foreground color
# global alertBox(after) - destroy alert box after n seconds
# global alertBox(anchor) - anchor for message box
# global alertBox(background) - background color
# global alertBox(font) - message font
# global alertBox(foreground) - foreground color
# global alertBox(justify) - justify for message box
# global alertBox(toplevelName) - the toplevel name

  global alertBox

  # check file existance
  if {"$alertBoxInFile" == ""} {
    puts stderr "No filedescriptor specified"
    return
  }

  set alertBoxMessage [read $alertBoxInFile]
  close $alertBoxInFile

  # show alert box
  if {[llength $args] > 0} {
    eval AlertBoxInternal "\{$alertBoxMessage\}" "\{$alertBoxCommand\}" "\{$alertBoxGeometry\}" "\{$alertBoxTitle\}" $args
  } {
    AlertBoxInternal $alertBoxMessage $alertBoxCommand $alertBoxGeometry $alertBoxTitle
  }

  if {[llength $args] > 0} {
    # wait for the box to be destroyed
    update idletask
    grab $alertBox(toplevelName)
    tkwait window $alertBox(toplevelName)

    return $alertBox(button)
  }
}


# Procedure: AlertBoxFile
proc AlertBoxFile { {alertBoxFile ""} {alertBoxCommand ""} {alertBoxGeometry "350x150"} {alertBoxTitle "Alert box"} args} {
# xf ignore me 5
##########
# Procedure: AlertBoxFile
# Description: show alert box containing a file
# Arguments: {alertBoxFile} - filename to read
#            {alertBoxCommand} - the command to call after ok
#            {alertBoxGeometry} - the geometry for the window
#            {alertBoxTitle} - the title for the window
#            {args} - labels of buttons
# Returns: The number of the selected button, ot nothing
# Sideeffects: none
# Notes: there exist also functions called:
#          AlertBox - to display a passed string
#          AlertBoxFd - to read from an already opened filedescriptor
##########
#
# global alertBox(activeBackground) - active background color
# global alertBox(activeForeground) - active foreground color
# global alertBox(after) - destroy alert box after n seconds
# global alertBox(anchor) - anchor for message box
# global alertBox(background) - background color
# global alertBox(font) - message font
# global alertBox(foreground) - foreground color
# global alertBox(justify) - justify for message box
# global alertBox(toplevelName) - the toplevel name

  global alertBox

  # check file existance
  if {"$alertBoxFile" == ""} {
    puts stderr "No filename specified"
    return
  }

  if {[catch "open $alertBoxFile r" alertBoxInFile]} {
    puts stderr "$alertBoxInFile"
    return
  }

  set alertBoxMessage [read $alertBoxInFile]
  close $alertBoxInFile

  # show alert box
  if {[llength $args] > 0} {
    eval AlertBoxInternal "\{$alertBoxMessage\}" "\{$alertBoxCommand\}" "\{$alertBoxGeometry\}" "\{$alertBoxTitle\}" $args
  } {
    AlertBoxInternal $alertBoxMessage $alertBoxCommand $alertBoxGeometry $alertBoxTitle
  }

  if {[llength $args] > 0} {
    # wait for the box to be destroyed
    update idletask
    grab $alertBox(toplevelName)
    tkwait window $alertBox(toplevelName)

    return $alertBox(button)
  }
}


# Procedure: AlertBoxInternal
proc AlertBoxInternal { alertBoxMessage alertBoxCommand alertBoxGeometry alertBoxTitle args} {
# xf ignore me 6
  global alertBox

  set tmpButtonOpt ""
  set tmpFrameOpt ""
  set tmpMessageOpt ""
  if {"$alertBox(activeBackground)" != ""} {
    append tmpButtonOpt "-activebackground \"$alertBox(activeBackground)\" "
  }
  if {"$alertBox(activeForeground)" != ""} {
    append tmpButtonOpt "-activeforeground \"$alertBox(activeForeground)\" "
  }
  if {"$alertBox(background)" != ""} {
    append tmpButtonOpt "-background \"$alertBox(background)\" "
    append tmpFrameOpt "-background \"$alertBox(background)\" "
    append tmpMessageOpt "-background \"$alertBox(background)\" "
  }
  if {"$alertBox(font)" != ""} {
    append tmpButtonOpt "-font \"$alertBox(font)\" "
    append tmpMessageOpt "-font \"$alertBox(font)\" "
  }
  if {"$alertBox(foreground)" != ""} {
    append tmpButtonOpt "-foreground \"$alertBox(foreground)\" "
    append tmpMessageOpt "-foreground \"$alertBox(foreground)\" "
  }

  # start build of toplevel
  if {"[info commands XFDestroy]" != ""} {
    catch {XFDestroy $alertBox(toplevelName)}
  } {
    catch {destroy $alertBox(toplevelName)}
  }
  toplevel $alertBox(toplevelName)  -borderwidth 0
  catch "$alertBox(toplevelName) config $tmpFrameOpt"
  if {[catch "wm geometry $alertBox(toplevelName) $alertBoxGeometry"]} {
    wm geometry $alertBox(toplevelName) 350x150
  }
  wm title $alertBox(toplevelName) $alertBoxTitle
  wm maxsize $alertBox(toplevelName) 1000 1000
  wm minsize $alertBox(toplevelName) 100 100
  # end build of toplevel

  message $alertBox(toplevelName).message1  -anchor "$alertBox(anchor)"  -justify "$alertBox(justify)"  -relief raised  -text "$alertBoxMessage"
  catch "$alertBox(toplevelName).message1 config $tmpMessageOpt"

  set xfTmpWidth  [string range $alertBoxGeometry 0 [expr [string first x $alertBoxGeometry]-1]]
  if {"$xfTmpWidth" != ""} {
    # set message size
    catch "$alertBox(toplevelName).message1 configure  -width [expr $xfTmpWidth-10]"
  } {
    $alertBox(toplevelName).message1 configure  -aspect 1500
  }

  frame $alertBox(toplevelName).frame1  -borderwidth 0  -relief raised
  catch "$alertBox(toplevelName).frame1 config $tmpFrameOpt"

  set alertBoxCounter 0
  set buttonNum [llength $args]
  if {$buttonNum > 0} {
    while {$alertBoxCounter < $buttonNum} {
      button $alertBox(toplevelName).frame1.button$alertBoxCounter  -text "[lindex $args $alertBoxCounter]"  -command "
          global alertBox
          set alertBox(button) $alertBoxCounter
          if {\"\[info commands XFDestroy\]\" != \"\"} {
            catch {XFDestroy $alertBox(toplevelName)}
          } {
            catch {destroy $alertBox(toplevelName)}
          }"
      catch "$alertBox(toplevelName).frame1.button$alertBoxCounter config $tmpButtonOpt"

      pack append $alertBox(toplevelName).frame1  $alertBox(toplevelName).frame1.button$alertBoxCounter {left fillx expand}

      incr alertBoxCounter
    }
  } {
    button $alertBox(toplevelName).frame1.button0  -text "OK"  -command "
        global alertBox
        set alertBox(button) 0
        if {\"\[info commands XFDestroy\]\" != \"\"} {
          catch {XFDestroy $alertBox(toplevelName)}
        } {
          catch {destroy $alertBox(toplevelName)}
        }
        $alertBoxCommand"
    catch "$alertBox(toplevelName).frame1.button0 config $tmpButtonOpt"

    pack append $alertBox(toplevelName).frame1  $alertBox(toplevelName).frame1.button0 {left fillx expand}
  }

  # packing
  pack append $alertBox(toplevelName)  $alertBox(toplevelName).frame1 {bottom fill}  $alertBox(toplevelName).message1 {top fill expand}

  if {$alertBox(after) != 0} {
    after [expr $alertBox(after)*1000]  "catch \"$alertBox(toplevelName).frame1.button0 invoke\""
  }
}


# Procedure: FSBox
proc FSBox { {fsBoxMessage "Select file:"} {fsBoxFileName ""} {fsBoxActionOk ""} {fsBoxActionCancel ""}} {
# xf ignore me 5
##########
# Procedure: FSBox
# Description: show file selector box
# Arguments: fsBoxMessage - the text to display
#            fsBoxFileName - a file name that should be selected
#            fsBoxActionOk - the action that should be performed on ok
#            fsBoxActionCancel - the action that should be performed on cancel
# Returns: the filename that was selected, or nothing
# Sideeffects: none
##########
# 
# global fsBox(activeBackground) - active background color
# global fsBox(activeForeground) - active foreground color
# global fsBox(background) - background color
# global fsBox(font) - text font
# global fsBox(foreground) - foreground color
# global fsBox(extensions) - scan directory for extensions
# global fsBox(scrollActiveForeground) - scrollbar active background color
# global fsBox(scrollBackground) - scrollbar background color
# global fsBox(scrollForeground) - scrollbar foreground color
# global fsBox(scrollSide) - side where scrollbar is located

  global fsBox

  set tmpButtonOpt ""
  set tmpFrameOpt ""
  set tmpMessageOpt ""
  set tmpScaleOpt ""
  set tmpScrollOpt ""
  if {"$fsBox(activeBackground)" != ""} {
    append tmpButtonOpt "-activebackground \"$fsBox(activeBackground)\" "
  }
  if {"$fsBox(activeForeground)" != ""} {
    append tmpButtonOpt "-activeforeground \"$fsBox(activeForeground)\" "
  }
  if {"$fsBox(background)" != ""} {
    append tmpButtonOpt "-background \"$fsBox(background)\" "
    append tmpFrameOpt "-background \"$fsBox(background)\" "
    append tmpMessageOpt "-background \"$fsBox(background)\" "
  }
  if {"$fsBox(font)" != ""} {
    append tmpButtonOpt "-font \"$fsBox(font)\" "
    append tmpMessageOpt "-font \"$fsBox(font)\" "
  }
  if {"$fsBox(foreground)" != ""} {
    append tmpButtonOpt "-foreground \"$fsBox(foreground)\" "
    append tmpMessageOpt "-foreground \"$fsBox(foreground)\" "
  }
  if {"$fsBox(scrollActiveForeground)" != ""} {
    append tmpScrollOpt "-activeforeground \"$fsBox(scrollActiveForeground)\" "
  }
  if {"$fsBox(scrollBackground)" != ""} {
    append tmpScrollOpt "-background \"$fsBox(scrollBackground)\" "
  }
  if {"$fsBox(scrollForeground)" != ""} {
    append tmpScrollOpt "-foreground \"$fsBox(scrollForeground)\" "
  }

  if {[file exists [file tail $fsBoxFileName]] &&
      [IsAFile [file tail $fsBoxFileName]]} {
    set fsBox(name) [file tail $fsBoxFileName]
  } {
    set fsBox(name) ""
  }
  if {[file exists $fsBoxFileName] && [IsADir $fsBoxFileName]} {
    set fsBox(path) $fsBoxFileName
  } {
    if {"[file rootname $fsBoxFileName]" != "."} {
      set fsBox(path) [file rootname $fsBoxFileName]
    }
  }
  if {$fsBox(showPixmap)} {
    set fsBox(path) [string trimleft $fsBox(path) @]
  }
  if {"$fsBox(path)" != "" && [file exists $fsBox(path)] &&
      [IsADir $fsBox(path)]} {
    set fsBox(internalPath) $fsBox(path)
  } {
    if {"$fsBox(internalPath)" == "" ||
        ![file exists $fsBox(internalPath)]} {
      set fsBox(internalPath) [pwd]
    }
  }
  # build widget structure

  # start build of toplevel
  if {"[info commands XFDestroy]" != ""} {
    catch {XFDestroy .fsBox}
  } {
    catch {destroy .fsBox}
  }
  toplevel .fsBox  -borderwidth 0
  catch ".fsBox config $tmpFrameOpt"
  wm geometry .fsBox 350x300 
  wm title .fsBox {File select box}
  wm maxsize .fsBox 1000 1000
  wm minsize .fsBox 100 100
  # end build of toplevel

  label .fsBox.message1  -anchor c  -relief raised  -text "$fsBoxMessage"
  catch ".fsBox.message1 config $tmpMessageOpt"

  frame .fsBox.frame1  -borderwidth 0  -relief raised
  catch ".fsBox.frame1 config $tmpFrameOpt"

  button .fsBox.frame1.ok  -text "OK"  -command "
      global fsBox
      set fsBox(name) \[.fsBox.file.file get\]
      if {$fsBox(showPixmap)} {
        set fsBox(path) @\[.fsBox.path.path get\]
      } {
        set fsBox(path) \[.fsBox.path.path get\]
      }
      set fsBox(internalPath) \[.fsBox.path.path get\]
      $fsBoxActionOk
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy .fsBox}
      } {
        catch {destroy .fsBox}
      }"
  catch ".fsBox.frame1.ok config $tmpButtonOpt"

  button .fsBox.frame1.rescan  -text "Rescan"  -command {
      global fsBox
      FSBoxFSShow [.fsBox.path.path get]  [.fsBox.pattern.pattern get] $fsBox(all)}
  catch ".fsBox.frame1.rescan config $tmpButtonOpt"

  button .fsBox.frame1.cancel  -text "Cancel"  -command "
      global fsBox
      set fsBox(name) {}
      set fsBox(path) {}
      $fsBoxActionCancel
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy .fsBox}
      } {
        catch {destroy .fsBox}
      }"
  catch ".fsBox.frame1.cancel config $tmpButtonOpt"

  if {$fsBox(showPixmap)} {
    frame .fsBox.frame2  -borderwidth 0  -relief raised
    catch ".fsBox.frame2 config $tmpFrameOpt"

    scrollbar .fsBox.frame2.scrollbar3  -command {.fsBox.frame2.canvas2 xview}  -orient {horizontal}  -relief {raised}
    catch ".fsBox.frame2.scrollbar3 config $tmpScrollOpt"

    scrollbar .fsBox.frame2.scrollbar1  -command {.fsBox.frame2.canvas2 yview}  -relief {raised}
    catch ".fsBox.frame2.scrollbar1 config $tmpScrollOpt"

    canvas .fsBox.frame2.canvas2  -confine {true}  -relief {raised}  -scrollregion {0c 0c 20c 20c}  -width {100}  -xscrollcommand {.fsBox.frame2.scrollbar3 set}  -yscrollcommand {.fsBox.frame2.scrollbar1 set}
    catch ".fsBox.frame2.canvas2 config $tmpFrameOpt"

    .fsBox.frame2.canvas2 addtag currentBitmap withtag [.fsBox.frame2.canvas2 create bitmap 5 5 -anchor nw]
  }

  frame .fsBox.path  -borderwidth 0  -relief raised
  catch ".fsBox.path config $tmpFrameOpt"

  frame .fsBox.path.paths  -borderwidth 2  -relief raised
  catch ".fsBox.path.paths config $tmpFrameOpt"

  menubutton .fsBox.path.paths.paths  -borderwidth 0  -menu ".fsBox.path.paths.paths.menu"  -relief flat  -text "Pathname:"
  catch ".fsBox.path.paths.paths config $tmpButtonOpt"

  menu .fsBox.path.paths.paths.menu
  catch ".fsBox.path.paths.paths.menu config $tmpButtonOpt"

  .fsBox.path.paths.paths.menu add command  -label "[string trimright $fsBox(internalPath) {/@}]"  -command "
       global fsBox
       FSBoxFSShow \[.fsBox.path.path get\]  \[.fsBox.pattern.pattern get\] \$fsBox(all)
       .fsBox.path.path delete 0 end
       .fsBox.path.path insert 0 [string trimright $fsBox(internalPath) {/@}]"

  entry .fsBox.path.path  -relief raised
  catch ".fsBox.path.path config $tmpMessageOpt"

  if {![IsADir $fsBox(internalPath)]} {
    set $fsBox(internalPath) [pwd]
  }
  .fsBox.path.path insert 0 $fsBox(internalPath)

  frame .fsBox.pattern  -borderwidth 0  -relief raised
  catch ".fsBox.pattern config $tmpFrameOpt"

  frame .fsBox.pattern.patterns  -borderwidth 2  -relief raised
  catch ".fsBox.pattern.patterns config $tmpFrameOpt"

  menubutton .fsBox.pattern.patterns.patterns  -borderwidth 0  -menu ".fsBox.pattern.patterns.patterns.menu"  -relief flat  -text "Selection pattern:"
  catch ".fsBox.pattern.patterns.patterns config $tmpButtonOpt"

  menu .fsBox.pattern.patterns.patterns.menu
  catch ".fsBox.pattern.patterns.patterns.menu config $tmpButtonOpt"

  .fsBox.pattern.patterns.patterns.menu add checkbutton  -label "Scan extensions"  -variable fsBox(extensions)  -command {
      global fsBox
      FSBoxFSShow [.fsBox.path.path get]  [.fsBox.pattern.pattern get] $fsBox(all)}

  entry .fsBox.pattern.pattern  -relief raised
  catch ".fsBox.pattern.pattern config $tmpMessageOpt"

  .fsBox.pattern.pattern insert 0 $fsBox(pattern)
  
  frame .fsBox.files  -borderwidth 0  -relief raised
  catch ".fsBox.files config $tmpFrameOpt"

  scrollbar .fsBox.files.vscroll  -relief raised  -command ".fsBox.files.files yview"
  catch ".fsBox.files.vscroll config $tmpScrollOpt"

  scrollbar .fsBox.files.hscroll  -orient horiz  -relief raised  -command ".fsBox.files.files xview"
  catch ".fsBox.files.hscroll config $tmpScrollOpt"

  listbox .fsBox.files.files  -exportselection false  -relief raised  -xscrollcommand ".fsBox.files.hscroll set"  -yscrollcommand ".fsBox.files.vscroll set"
  catch ".fsBox.files.files config $tmpMessageOpt"

  frame .fsBox.file  -borderwidth 0  -relief raised
  catch ".fsBox.file config $tmpFrameOpt"

  label .fsBox.file.labelfile  -relief raised  -text "Filename:"
  catch ".fsBox.file.labelfile config $tmpMessageOpt"

  entry .fsBox.file.file  -relief raised
  catch ".fsBox.file.file config $tmpMessageOpt"

  .fsBox.file.file delete 0 end
  .fsBox.file.file insert 0 $fsBox(name)
  
  checkbutton .fsBox.pattern.all  -offvalue 0  -onvalue 1  -text "Show all files"  -variable fsBox(all)  -command {
      global fsBox
      FSBoxFSShow [.fsBox.path.path get]  [.fsBox.pattern.pattern get] $fsBox(all)}
  catch ".fsBox.pattern.all config $tmpButtonOpt"

  FSBoxFSShow $fsBox(internalPath) $fsBox(pattern) $fsBox(all)

  # bindings
  bind .fsBox.files.files <Double-Button-1> "
    FSBoxFSFileSelectDouble %W $fsBox(showPixmap) \{$fsBoxActionOk\} %y"
  bind .fsBox.files.files <ButtonPress-1> "
    FSBoxFSFileSelect %W $fsBox(showPixmap) %y"
  bind .fsBox.files.files <Button1-Motion> "
    FSBoxFSFileSelect %W $fsBox(showPixmap) %y"
  bind .fsBox.files.files <Shift-Button1-Motion> "
    FSBoxFSFileSelect %W $fsBox(showPixmap) %y"
  bind .fsBox.files.files <Shift-ButtonPress-1> "
    FSBoxFSFileSelect %W $fsBox(showPixmap) %y"

  bind .fsBox.path.path <Tab> {
    FSBoxFSNameComplete path}
  bind .fsBox.path.path <Return> {
    global tkVersion
    global fsBox
    FSBoxFSShow [.fsBox.path.path get]  [.fsBox.pattern.pattern get] $fsBox(all)
    FSBoxFSInsertPath
    if {$tkVersion >= 3.0} {
      .fsBox.file.file icursor end
    } {
      .fsBox.file.file cursor end
    }
    focus .fsBox.file.file}
  catch "bind .fsBox.path.path <Up> {}"
  bind .fsBox.path.path <Down> {
    global tkVersion
    if {$tkVersion >= 3.0} {
      .fsBox.file.file icursor end
    } {
      .fsBox.file.file cursor end
    }
    focus .fsBox.file.file}

  bind .fsBox.file.file <Tab> {
    FSBoxFSNameComplete file}
  bind .fsBox.file.file <Return> "
    global fsBox
    set fsBox(name) \[.fsBox.file.file get\]
    if {$fsBox(showPixmap)} {
      set fsBox(path) @\[.fsBox.path.path get\]
    } {
      set fsBox(path) \[.fsBox.path.path get\]
    }
    set fsBox(internalPath) \[.fsBox.path.path get\]
    $fsBoxActionOk
    if {\"\[info commands XFDestroy\]\" != \"\"} {
      catch {XFDestroy .fsBox}
    } {
      catch {destroy .fsBox}
    }"
  bind .fsBox.file.file <Up> {
    global tkVersion
    if {$tkVersion >= 3.0} {
      .fsBox.path.path icursor end
    } {
      .fsBox.path.path cursor end
    }
    focus .fsBox.path.path}
  bind .fsBox.file.file <Down> {
    global tkVersion
    if {$tkVersion >= 3.0} {
      .fsBox.pattern.pattern icursor end
    } {
      .fsBox.pattern.pattern cursor end
    }
    focus .fsBox.pattern.pattern}

  bind .fsBox.pattern.pattern <Return> {
    global fsBox
    FSBoxFSShow [.fsBox.path.path get]  [.fsBox.pattern.pattern get] $fsBox(all)}
  bind .fsBox.pattern.pattern <Up> {
    global tkVersion
    if {$tkVersion >= 3.0} {
      .fsBox.file.file icursor end
    } {
      .fsBox.file.file cursor end
    }
    focus .fsBox.file.file}
  catch "bind .fsBox.pattern.pattern <Down> {}"

  # packing
  pack append .fsBox.files  .fsBox.files.vscroll "$fsBox(scrollSide) filly"  .fsBox.files.hscroll {bottom fillx}  .fsBox.files.files {left fill expand}
  pack append .fsBox.file  .fsBox.file.labelfile {left}  .fsBox.file.file {left fill expand}
  pack append .fsBox.frame1  .fsBox.frame1.ok {left fill expand}  .fsBox.frame1.rescan {left fill expand}  .fsBox.frame1.cancel {left fill expand}
  pack append .fsBox.path.paths  .fsBox.path.paths.paths {left}
  pack append .fsBox.pattern.patterns  .fsBox.pattern.patterns.patterns {left}
  pack append .fsBox.path  .fsBox.path.paths {left}  .fsBox.path.path {left fill expand}
  pack append .fsBox.pattern  .fsBox.pattern.patterns {left}  .fsBox.pattern.all {right fill}  .fsBox.pattern.pattern {left fill expand}
  if {$fsBox(showPixmap)} {
    pack append .fsBox.frame2  .fsBox.frame2.scrollbar1 {left filly}  .fsBox.frame2.canvas2 {top expand fill}  .fsBox.frame2.scrollbar3 {top fillx} 

    pack append .fsBox  .fsBox.message1 {top fill}  .fsBox.frame1 {bottom fill}  .fsBox.pattern {bottom fill}  .fsBox.file {bottom fill}  .fsBox.path {bottom fill}  .fsBox.frame2 {right fill}  .fsBox.files {left fill expand}
  } {
    pack append .fsBox  .fsBox.message1 {top fill}  .fsBox.frame1 {bottom fill}  .fsBox.pattern {bottom fill}  .fsBox.file {bottom fill}  .fsBox.path {bottom fill}  .fsBox.files {left fill expand}
  }

  if {"$fsBoxActionOk" == "" && "$fsBoxActionCancel" == ""} {
    # wait for the box to be destroyed
    update idletask
    grab .fsBox
    tkwait window .fsBox

    if {"[string trim $fsBox(path)]" != "" ||
        "[string trim $fsBox(name)]" != ""} {
      if {"[string trimleft [string trim $fsBox(name)] /]" == ""} {
        return [string trimright [string trim $fsBox(path)] /]
      } {
        return [string trimright [string trim $fsBox(path)] /]/[string trimleft [string trim $fsBox(name)] /]
      }
    }
  }
}


# Procedure: FSBoxBindSelectOne
proc FSBoxBindSelectOne { fsBoxW fsBoxY} {
# xf ignore me 6

  set fsBoxNearest [$fsBoxW nearest $fsBoxY]
  if {$fsBoxNearest >= 0} {
    $fsBoxW select from $fsBoxNearest
    $fsBoxW select to $fsBoxNearest
  }
}


# Procedure: FSBoxFSFileSelect
proc FSBoxFSFileSelect { fsBoxW fsBoxShowPixmap fsBoxY} {
# xf ignore me 6
  global fsBox

  FSBoxBindSelectOne $fsBoxW $fsBoxY
  set fsBoxNearest [$fsBoxW nearest $fsBoxY]
  if {$fsBoxNearest >= 0} {
    set fsBoxTmpEntry [$fsBoxW get $fsBoxNearest]
    if {"[string index $fsBoxTmpEntry  [expr [string length $fsBoxTmpEntry]-1]]" == "/" ||
        "[string index $fsBoxTmpEntry  [expr [string length $fsBoxTmpEntry]-1]]" == "@"} {
      set fsBoxFileName [string range $fsBoxTmpEntry 0  [expr [string length $fsBoxTmpEntry]-2]]
      if {![IsADir [string trimright $fsBox(internalPath)/$fsBoxFileName @]] &&
          ![IsASymlink [string trimright $fsBox(internalPath)/$fsBoxFileName @]]} {
        set fsBoxFileName $fsBoxTmpEntry
      }
    } {
      if {"[string index $fsBoxTmpEntry  [expr [string length $fsBoxTmpEntry]-1]]" == "*"} {
        set fsBoxFileName [string range $fsBoxTmpEntry 0  [expr [string length $fsBoxTmpEntry]-2]]
        if {![file executable $fsBox(internalPath)/$fsBoxFileName]} {
          set fsBoxFileName $fsBoxTmpEntry
        }
      } {
        set fsBoxFileName $fsBoxTmpEntry
      }
    }
    if {![IsADir [string trimright $fsBox(internalPath)/$fsBoxFileName @]]} {
      set fsBox(name) $fsBoxFileName
      .fsBox.file.file delete 0 end
      .fsBox.file.file insert 0 $fsBox(name)
      if {$fsBoxShowPixmap} {
        catch ".fsBox.frame2.canvas2 itemconfigure currentBitmap -bitmap \"@$fsBox(internalPath)/$fsBox(name)\""
      }
    }
  }
}


# Procedure: FSBoxFSFileSelectDouble
proc FSBoxFSFileSelectDouble { fsBoxW fsBoxShowPixmap fsBoxAction fsBoxY} {
# xf ignore me 6
  global fsBox

  FSBoxBindSelectOne $fsBoxW $fsBoxY
  set fsBoxNearest [$fsBoxW nearest $fsBoxY]
  if {$fsBoxNearest >= 0} {
    set fsBoxTmpEntry [$fsBoxW get $fsBoxNearest]
    if {"$fsBoxTmpEntry" == "../"} {
      set fsBoxTmpEntry [string trimright [string trim $fsBox(internalPath)] "@/"]
      if {"$fsBoxTmpEntry" == ""} {
        return
      }
      FSBoxFSShow [file dirname $fsBoxTmpEntry]  [.fsBox.pattern.pattern get] $fsBox(all)
      .fsBox.path.path delete 0 end
      .fsBox.path.path insert 0 $fsBox(internalPath)
    } {
      if {"[string index $fsBoxTmpEntry  [expr [string length $fsBoxTmpEntry]-1]]" == "/" ||
          "[string index $fsBoxTmpEntry  [expr [string length $fsBoxTmpEntry]-1]]" == "@"} {
        set fsBoxFileName [string range $fsBoxTmpEntry 0  [expr [string length $fsBoxTmpEntry]-2]]
        if {![IsADir [string trimright $fsBox(internalPath)/$fsBoxFileName @]] &&
            ![IsASymlink [string trimright $fsBox(internalPath)/$fsBoxFileName @]]} {
          set fsBoxFileName $fsBoxTmpEntry
        }
      } {
        if {"[string index $fsBoxTmpEntry  [expr [string length $fsBoxTmpEntry]-1]]" == "*"} {
          set fsBoxFileName [string range $fsBoxTmpEntry 0  [expr [string length $fsBoxTmpEntry]-2]]
          if {![file executable $fsBox(internalPath)/$fsBoxFileName]} {
            set fsBoxFileName $fsBoxTmpEntry
          }
        } {
          set fsBoxFileName $fsBoxTmpEntry
        }
      }
      if {[IsADir [string trimright $fsBox(internalPath)/$fsBoxFileName @]]} {
        set fsBox(internalPath) "[string trimright $fsBox(internalPath) {/@}]/$fsBoxFileName"
        FSBoxFSShow $fsBox(internalPath)  [.fsBox.pattern.pattern get] $fsBox(all)
        .fsBox.path.path delete 0 end
        .fsBox.path.path insert 0 $fsBox(internalPath)
      } {
        set fsBox(name) $fsBoxFileName
        if {$fsBoxShowPixmap} {
          set fsBox(path) @$fsBox(internalPath)
        } {
          set fsBox(path) $fsBox(internalPath)
        }
        if {"$fsBoxAction" != ""} {
          eval "global fsBox; $fsBoxAction"
        }
        if {"[info commands XFDestroy]" != ""} {
          catch {XFDestroy .fsBox}
        } {
          catch {destroy .fsBox}
        }
      }
    }
  }
}


# Procedure: FSBoxFSInsertPath
proc FSBoxFSInsertPath {} {
# xf ignore me 6
  global fsBox

  set fsBoxLast [.fsBox.path.paths.paths.menu index last]
  set fsBoxNewEntry [string trimright [.fsBox.path.path get] "/@"]
  for {set fsBoxCounter 0} {$fsBoxCounter <= $fsBoxLast} {incr fsBoxCounter 1} {
    if {"$fsBoxNewEntry" ==  "[lindex [.fsBox.path.paths.paths.menu entryconfigure  $fsBoxCounter -label] 4]"} {
      return
    }
  }
  if {$fsBoxLast < 9} {
    .fsBox.path.paths.paths.menu add command  -label "$fsBoxNewEntry"  -command "
        global fsBox
        FSBoxFSShow $fsBoxNewEntry  \[.fsBox.pattern.pattern get\] \$fsBox(all)
        .fsBox.path.path delete 0 end
        .fsBox.path.path insert 0 $fsBoxNewEntry"
  } {
    for {set fsBoxCounter 0} {$fsBoxCounter < $fsBoxLast} {incr fsBoxCounter 1} {
      .fsBox.path.paths.paths.menu entryconfigure  $fsBoxCounter -label  [lindex [.fsBox.path.paths.paths.menu entryconfigure  [expr $fsBoxCounter+1] -label] 4]
      .fsBox.path.paths.paths.menu entryconfigure $fsBoxCounter  -command "
          global fsBox
          FSBoxFSShow [lindex [.fsBox.path.paths.paths.menu entryconfigure  [expr $fsBoxCounter+1] -label] 4]  \[.fsBox.pattern.pattern get\] \$fsBox(all)
          .fsBox.path.path delete 0 end
          .fsBox.path.path insert 0 [lindex  [.fsBox.path.paths.paths.menu entryconfigure  [expr $fsBoxCounter+1] -label] 4]"
    }
    .fsBox.path.paths.paths.menu entryconfigure $fsBoxLast  -label "$fsBoxNewEntry"
    .fsBox.path.paths.paths.menu entryconfigure $fsBoxCounter  -command "
        global fsBox
        FSBoxFSShow \[.fsBox.path.path get\]  \[.fsBox.pattern.pattern get\] \$fsBox(all)
        .fsBox.path.path delete 0 end
        .fsBox.path.path insert 0 $fsBoxNewEntry"
  }
}


# Procedure: FSBoxFSNameComplete
proc FSBoxFSNameComplete { fsBoxType} {
# xf ignore me 6
  global tkVersion
  global fsBox

  set fsBoxNewFile ""
  if {"$fsBoxType" == "path"} {
    set fsBoxDirName [file dirname [.fsBox.path.path get]]
    set fsBoxFileName [file tail [.fsBox.path.path get]]
  } {
    set fsBoxDirName [file dirname [.fsBox.path.path get]/]
    set fsBoxFileName [file tail [.fsBox.file.file get]]
  }

  set fsBoxNewFile ""
  if {[IsADir [string trimright $fsBoxDirName @]]} {
    catch "glob -nocomplain $fsBoxDirName/${fsBoxFileName}*" fsBoxResult
    foreach fsBoxCounter $fsBoxResult {
      if {"$fsBoxNewFile" == ""} {
        set fsBoxNewFile [file tail $fsBoxCounter]
      } {
        if {"[string index [file tail $fsBoxCounter] 0]" !=
            "[string index $fsBoxNewFile 0]"} {
          set fsBoxNewFile ""
          break
        }
        set fsBoxCounter1 0
        set fsBoxTmpFile1 $fsBoxNewFile
        set fsBoxTmpFile2 [file tail $fsBoxCounter]
        set fsBoxLength1 [string length $fsBoxTmpFile1]
        set fsBoxLength2 [string length $fsBoxTmpFile2]
        set fsBoxNewFile ""
        if {$fsBoxLength1 > $fsBoxLength2} {
          set fsBoxLength1 $fsBoxLength2
        }
        while {$fsBoxCounter1 < $fsBoxLength1} {
          if {"[string index $fsBoxTmpFile1 $fsBoxCounter1]" ==  "[string index $fsBoxTmpFile2 $fsBoxCounter1]"} {
            append fsBoxNewFile [string index $fsBoxTmpFile1 $fsBoxCounter1]
          } {
            break
          }
          incr fsBoxCounter1 1
        }
      }
    }
  }
  if {"$fsBoxNewFile" != ""} {
    if {[IsADir [string trimright $fsBoxDirName/$fsBoxNewFile @]] ||
        ![IsAFile [string trimright $fsBoxDirName/$fsBoxNewFile @]]} {
      if {[IsADir [string trimright $fsBoxDirName/$fsBoxNewFile @]]} {
        if {"$fsBoxDirName" == "/"} {
          .fsBox.path.path delete 0 end
          .fsBox.path.path insert 0 "/[string trimright [string trim $fsBoxNewFile /] @]/"
        } {
          .fsBox.path.path delete 0 end
          .fsBox.path.path insert 0 "[string trimright $fsBoxDirName /]/[string trimright [string trim $fsBoxNewFile /] @]/"
        }
        FSBoxFSShow [.fsBox.path.path get]  [.fsBox.pattern.pattern get] $fsBox(all)
        FSBoxFSInsertPath
      } {
        .fsBox.path.path delete 0 end
        .fsBox.path.path insert 0 "[string trimright $fsBoxDirName /]/[string trimright [string trim $fsBoxNewFile /] @]"
      }
    } {
      .fsBox.path.path delete 0 end
      .fsBox.path.path insert 0 "[string trimright $fsBoxDirName {@/}]/"
      .fsBox.file.file delete 0 end
      .fsBox.file.file insert 0 $fsBoxNewFile
      if {$tkVersion >= 3.0} {
        .fsBox.file.file icursor end
      } {
        .fsBox.file.file cursor end
      }
      focus .fsBox.file.file
    }
  }
}


# Procedure: FSBoxFSShow
proc FSBoxFSShow { fsBoxPath fsBoxPattern fsBoxAll} {
# xf ignore me 6
  global fsBox

  set tmpButtonOpt ""
  if {"$fsBox(activeBackground)" != ""} {
    append tmpButtonOpt "-activebackground \"$fsBox(activeBackground)\" "
  }
  if {"$fsBox(activeForeground)" != ""} {
    append tmpButtonOpt "-activeforeground \"$fsBox(activeForeground)\" "
  }
  if {"$fsBox(background)" != ""} {
    append tmpButtonOpt "-background \"$fsBox(background)\" "
  }
  if {"$fsBox(font)" != ""} {
    append tmpButtonOpt "-font \"$fsBox(font)\" "
  }
  if {"$fsBox(foreground)" != ""} {
    append tmpButtonOpt "-foreground \"$fsBox(foreground)\" "
  }

  set fsBox(pattern) $fsBoxPattern
  if {[file exists $fsBoxPath] && [file readable $fsBoxPath] &&
      [IsADir $fsBoxPath]} {
    set fsBox(internalPath) $fsBoxPath
  } {
    if {[file exists $fsBoxPath] && [file readable $fsBoxPath] &&
        [IsAFile $fsBoxPath]} {
      set fsBox(internalPath) [file dirname $fsBoxPath]
      .fsBox.file.file delete 0 end
      .fsBox.file.file insert 0 [file tail $fsBoxPath]
      set fsBoxPath $fsBox(internalPath)
    } {
      while {"$fsBoxPath" != "" && "$fsBoxPath" != "/" &&
             ![file isdirectory $fsBoxPath]} {
        set fsBox(internalPath) [file dirname $fsBoxPath]
         set fsBoxPath $fsBox(internalPath)
      }
    }
  }
  if {"$fsBoxPath" == ""} {
    set fsBoxPath "/"
    set fsBox(internalPath) "/"
  }
  .fsBox.path.path delete 0 end
  .fsBox.path.path insert 0 $fsBox(internalPath)

  if {[.fsBox.files.files size] > 0} {
    .fsBox.files.files delete 0 end
  }
  if {$fsBoxAll} {
    if {[catch "exec ls -F -a $fsBoxPath" fsBoxResult]} {
      puts stderr "$fsBoxResult"
    }
  } {
    if {[catch "exec ls -F $fsBoxPath" fsBoxResult]} {
      puts stderr "$fsBoxResult"
    }
  }
  set fsBoxElementList [lsort $fsBoxResult]

  foreach fsBoxCounter [winfo children .fsBox.pattern.patterns.patterns] {
    if {[string length [info commands XFDestroy]] > 0} {
      catch {XFDestroy $fsBoxCounter}
    } {
      catch {destroy $fsBoxCounter}
    }
  }
  menu .fsBox.pattern.patterns.patterns.menu
  catch ".fsBox.pattern.patterns.patterns.menu config $tmpButtonOpt"

  if {$fsBox(extensions)} {
    .fsBox.pattern.patterns.patterns.menu add command  -label "*"  -command {
        global fsBox
        set fsBox(pattern) "*"
        .fsBox.pattern.pattern delete 0 end
        .fsBox.pattern.pattern insert 0 $fsBox(pattern)
        FSBoxFSShow [.fsBox.path.path get] $fsBox(pattern)  $fsBox(all)}
  }

  if {"$fsBoxPath" != "/"} {
    .fsBox.files.files insert end "../"
  }
  foreach fsBoxCounter $fsBoxElementList {
    if {[string match $fsBoxPattern $fsBoxCounter] ||
        [IsADir [string trimright $fsBoxPath/$fsBoxCounter "/@"]]} {
      if {"$fsBoxCounter" != "../" &&
          "$fsBoxCounter" != "./"} {
        .fsBox.files.files insert end $fsBoxCounter
      }
    }

    if {$fsBox(extensions)} {
      catch "file rootname $fsBoxCounter" fsBoxRootName
      catch "file extension $fsBoxCounter" fsBoxExtension
      set fsBoxExtension [string trimright $fsBoxExtension "/*@"]
      if {"$fsBoxExtension" != "" && "$fsBoxRootName" != ""} {
        set fsBoxInsert 1
        set fsBoxLast [.fsBox.pattern.patterns.patterns.menu index last]
        for {set fsBoxCounter1 0} {$fsBoxCounter1 <= $fsBoxLast} {incr fsBoxCounter1 1} {
          if {"*$fsBoxExtension" ==  "[lindex [.fsBox.pattern.patterns.patterns.menu entryconfigure  $fsBoxCounter1 -label] 4]"} {
            set fsBoxInsert 0
          }
        }
	if {$fsBoxInsert} {
          .fsBox.pattern.patterns.patterns.menu add command  -label "*$fsBoxExtension"  -command "
              global fsBox
              set fsBox(pattern) \"*$fsBoxExtension\"
              .fsBox.pattern.pattern delete 0 end
              .fsBox.pattern.pattern insert 0 \$fsBox(pattern)
              FSBoxFSShow \[.fsBox.path.path get\] \$fsBox(pattern)  \$fsBox(all)"
        }
      }
    }
  }
  if {$fsBox(extensions)} {
    .fsBox.pattern.patterns.patterns.menu add separator
  }
  if {$fsBox(extensions) || 
      "[.fsBox.pattern.patterns.patterns.menu index last]" == "none"} {
    .fsBox.pattern.patterns.patterns.menu add checkbutton  -label "Scan extensions"  -variable "fsBox(extensions)"  -command {
        global fsBox
        FSBoxFSShow [.fsBox.path.path get]  [.fsBox.pattern.pattern get] $fsBox(all)}
  }
}


# Procedure: InputBoxInternal
proc InputBoxInternal { inputBoxMessage inputBoxCommandOk inputBoxCommandCancel inputBoxGeometry inputBoxTitle lineNum} {
# xf ignore me 6
  global inputBox

  set tmpButtonOpt ""
  set tmpFrameOpt ""
  set tmpMessageOpt ""
  set tmpScaleOpt ""
  set tmpScrollOpt ""
  if {"$inputBox(activeBackground)" != ""} {
    append tmpButtonOpt "-activebackground \"$inputBox(activeBackground)\" "
  }
  if {"$inputBox(activeForeground)" != ""} {
    append tmpButtonOpt "-activeforeground \"$inputBox(activeForeground)\" "
  }
  if {"$inputBox(background)" != ""} {
    append tmpButtonOpt "-background \"$inputBox(background)\" "
    append tmpFrameOpt "-background \"$inputBox(background)\" "
    append tmpMessageOpt "-background \"$inputBox(background)\" "
  }
  if {"$inputBox(font)" != ""} {
    append tmpButtonOpt "-font \"$inputBox(font)\" "
    append tmpMessageOpt "-font \"$inputBox(font)\" "
  }
  if {"$inputBox(foreground)" != ""} {
    append tmpButtonOpt "-foreground \"$inputBox(foreground)\" "
    append tmpMessageOpt "-foreground \"$inputBox(foreground)\" "
  }
  if {"$inputBox(scrollActiveForeground)" != ""} {
    append tmpScrollOpt "-activeforeground \"$inputBox(scrollActiveForeground)\" "
  }
  if {"$inputBox(scrollBackground)" != ""} {
    append tmpScrollOpt "-background \"$inputBox(scrollBackground)\" "
  }
  if {"$inputBox(scrollForeground)" != ""} {
    append tmpScrollOpt "-foreground \"$inputBox(scrollForeground)\" "
  }

  # start build of toplevel
  if {"[info commands XFDestroy]" != ""} {
    catch {XFDestroy $inputBox(toplevelName)}
  } {
    catch {destroy $inputBox(toplevelName)}
  }
  toplevel $inputBox(toplevelName)  -borderwidth 0
  catch "$inputBox(toplevelName) config $tmpFrameOpt"
  if {[catch "wm geometry $inputBox(toplevelName) $inputBoxGeometry"]} {
    wm geometry $inputBox(toplevelName) 350x150
  }
  wm title $inputBox(toplevelName) $inputBoxTitle
  wm maxsize $inputBox(toplevelName) 1000 1000
  wm minsize $inputBox(toplevelName) 100 100
  # end build of toplevel

  message $inputBox(toplevelName).message1  -anchor "$inputBox(anchor)"  -justify "$inputBox(justify)"  -relief raised  -text "$inputBoxMessage"
  catch "$inputBox(toplevelName).message1 config $tmpMessageOpt"

  set xfTmpWidth  [string range $inputBoxGeometry 0 [expr [string first x $inputBoxGeometry]-1]]
  if {"$xfTmpWidth" != ""} {
    # set message size
    catch "$inputBox(toplevelName).message1 configure  -width [expr $xfTmpWidth-10]"
  } {
    $inputBox(toplevelName).message1 configure  -aspect 1500
  }

  frame $inputBox(toplevelName).frame0  -borderwidth 0  -relief raised
  catch "$inputBox(toplevelName).frame0 config $tmpFrameOpt"

  frame $inputBox(toplevelName).frame1  -borderwidth 0  -relief raised
  catch "$inputBox(toplevelName).frame1 config $tmpFrameOpt"

  if {$lineNum == 1} {
    scrollbar $inputBox(toplevelName).frame1.hscroll  -orient "horizontal"  -relief raised  -command "$inputBox(toplevelName).frame1.input view"
    catch "$inputBox(toplevelName).frame1.hscroll config $tmpScrollOpt"

    entry $inputBox(toplevelName).frame1.input  -relief raised  -scrollcommand "$inputBox(toplevelName).frame1.hscroll set"
    catch "$inputBox(toplevelName).frame1.input config $tmpMessageOpt"

    $inputBox(toplevelName).frame1.input insert 0  $inputBox($inputBox(toplevelName),inputOne)
    
    # bindings
    bind $inputBox(toplevelName).frame1.input <Return> "
      global inputBox
      set inputBox($inputBox(toplevelName),inputOne) \[$inputBox(toplevelName).frame1.input get\]
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy $inputBox(toplevelName)}
      } {
        catch {destroy $inputBox(toplevelName)}
      }
      $inputBoxCommandOk"
    
    # packing
    pack append $inputBox(toplevelName).frame1  $inputBox(toplevelName).frame1.hscroll {bottom fill}  $inputBox(toplevelName).frame1.input {top fill expand}
  } {
    text $inputBox(toplevelName).frame1.input  -relief raised  -wrap none  -borderwidth 2  -yscrollcommand "$inputBox(toplevelName).frame1.vscroll set"
    catch "$inputBox(toplevelName).frame1.input config $tmpMessageOpt"

    scrollbar $inputBox(toplevelName).frame1.vscroll  -relief raised  -command "$inputBox(toplevelName).frame1.input yview"
    catch "$inputBox(toplevelName).frame1.vscroll config $tmpScrollOpt"

    $inputBox(toplevelName).frame1.input insert 1.0  $inputBox($inputBox(toplevelName),inputMulti)

    # bindings
    bind $inputBox(toplevelName).frame1.input <Control-Return> "
      global inputBox
      set inputBox($inputBox(toplevelName),inputMulti) \[$inputBox(toplevelName).frame1.input get 1.0 end\]
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy $inputBox(toplevelName)}
      } {
        catch {destroy $inputBox(toplevelName)}
      }
      $inputBoxCommandOk"
    bind $inputBox(toplevelName).frame1.input <Meta-Return> "
      global inputBox
      set inputBox($inputBox(toplevelName),inputMulti) \[$inputBox(toplevelName).frame1.input get 1.0 end\]
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy $inputBox(toplevelName)}
      } {
        catch {destroy $inputBox(toplevelName)}
      }
      $inputBoxCommandOk"

    # packing
    pack append $inputBox(toplevelName).frame1  $inputBox(toplevelName).frame1.vscroll "$inputBox(scrollSide) filly"  $inputBox(toplevelName).frame1.input {left fill expand}
  }
  
  button $inputBox(toplevelName).frame0.button0  -text "OK"  -command "
      global inputBox
      if {$lineNum == 1} {
        set inputBox($inputBox(toplevelName),inputOne) \[$inputBox(toplevelName).frame1.input get\]
      } {
        set inputBox($inputBox(toplevelName),inputMulti) \[$inputBox(toplevelName).frame1.input get 1.0 end\]
      }
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy $inputBox(toplevelName)}
      } {
        catch {destroy $inputBox(toplevelName)}
      }
      $inputBoxCommandOk"
  catch "$inputBox(toplevelName).frame0.button0 config $tmpButtonOpt"

  button $inputBox(toplevelName).frame0.button1  -text "Cancel"  -command "
      global inputBox
      if {$lineNum == 1} {
        set inputBox($inputBox(toplevelName),inputOne) \"\"
      } {
        set inputBox($inputBox(toplevelName),inputMulti) \"\"
      }
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy $inputBox(toplevelName)}
      } {
        catch {destroy $inputBox(toplevelName)}
      }
      $inputBoxCommandCancel"
  catch "$inputBox(toplevelName).frame0.button1 config $tmpButtonOpt"

  pack append $inputBox(toplevelName).frame0  $inputBox(toplevelName).frame0.button0 {left fill expand}  $inputBox(toplevelName).frame0.button1 {left fill expand}

  pack append $inputBox(toplevelName)  $inputBox(toplevelName).frame0 {bottom fill}  $inputBox(toplevelName).frame1 {bottom fill expand}  $inputBox(toplevelName).message1 {top fill}
}


# Procedure: InputBoxMulti
proc InputBoxMulti { {inputBoxMessage "Input box:"} {inputBoxCommandOk ""} {inputBoxCommandCancel ""} {inputBoxGeometry "350x150"} {inputBoxTitle "Input box"}} {
# xf ignore me 5
##########
# Procedure: InputBoxMulti
# Description: show input box with one text line
# Arguments: {inputBoxMessage} - message to display
#            {inputBoxCommandOk} - the command to call after ok
#            {inputBoxCommandCancel} - the command to call after cancel
#            {inputBoxGeometry} - the geometry for the window
#            {inputBoxTitle} - the title for the window
# Returns: The entered text
# Sideeffects: none
# Notes: there exist also a function called:
#          InputBoxOne - to enter one line text
##########
#
# global inputBox(activeBackground) - active background color
# global inputBox(activeForeground) - active foreground color
# global inputBox(anchor) - anchor for message box
# global inputBox(background) - background color
# global inputBox(erase) - erase previous text
# global inputBox(font) - message font
# global inputBox(foreground) - foreground color
# global inputBox(justify) - justify for message box
# global inputBox(scrollActiveForeground) - scrollbar active background color
# global inputBox(scrollBackground) - scrollbar background color
# global inputBox(scrollForeground) - scrollbar foreground color
# global inputBox(scrollSide) - side where scrollbar is located
# global inputBox(toplevelName) - the toplevel name
# global inputBox(toplevelName,inputMulti) - the text in the text widget

  global inputBox

  if {"$inputBoxGeometry" == ""} {
    set inputBoxGeometry 350x150
  }
  if {$inputBox(erase)} {
    set inputBox($inputBox(toplevelName),inputMulti) ""
  } {
    if {![info exists inputBox($inputBox(toplevelName),inputMulti)]} {
      set inputBox($inputBox(toplevelName),inputMulti) ""
    }
  }
  InputBoxInternal $inputBoxMessage $inputBoxCommandOk $inputBoxCommandCancel $inputBoxGeometry $inputBoxTitle 2

  # wait for the box to be destroyed
  update idletask
  grab $inputBox(toplevelName)
  tkwait window $inputBox(toplevelName)

  return $inputBox($inputBox(toplevelName),inputMulti)
}


# Procedure: InputBoxOne
proc InputBoxOne { {inputBoxMessage "Input box:"} {inputBoxCommandOk ""} {inputBoxCommandCancel ""} {inputBoxGeometry "350x150"} {inputBoxTitle "Input box"}} {
# xf ignore me 5
##########
# Procedure: InputBoxOne
# Description: show input box with one text line
# Arguments: {inputBoxMessage} - message to display
#            {inputBoxCommandOk} - the command to call after ok
#            {inputBoxCommandCancel} - the command to call after cancel
#            {inputBoxGeometry} - the geometry for the window
#            {inputBoxTitle} - the title for the window
# Returns: The entered text
# Sideeffects: none
# Notes: there exist also a function called:
#          InputBoxMulti - to enter multiline text
##########
#
# global inputBox(activeBackground) - active background color
# global inputBox(activeForeground) - active foreground color
# global inputBox(anchor) - anchor for message box
# global inputBox(background) - background color
# global inputBox(erase) - erase previous text
# global inputBox(font) - message font
# global inputBox(foreground) - foreground color
# global inputBox(justify) - justify for message box
# global inputBox(scrollActiveForeground) - scrollbar active background color
# global inputBox(scrollBackground) - scrollbar background color
# global inputBox(scrollForeground) - scrollbar foreground color
# global inputBox(scrollSide) - side where scrollbar is located
# global inputBox(toplevelName) - the toplevel name
# global inputBox(toplevelName,inputOne) - the text in the entry widget

  global inputBox

  if {$inputBox(erase)} {
    set inputBox($inputBox(toplevelName),inputOne) ""
  } {
    if {![info exists inputBox($inputBox(toplevelName),inputOne)]} {
      set inputBox($inputBox(toplevelName),inputOne) ""
    }
  }
  InputBoxInternal $inputBoxMessage $inputBoxCommandOk $inputBoxCommandCancel $inputBoxGeometry $inputBoxTitle 1

  # wait for the box to be destroyed
  update idletask
  grab $inputBox(toplevelName)
  tkwait window $inputBox(toplevelName)

  return $inputBox($inputBox(toplevelName),inputOne)
}


# Procedure: IsADir
proc IsADir { pathName} {
# xf ignore me 5
##########
# Procedure: IsADir
# Description: check if name is a directory (including symbolic links)
# Arguments: pathName - the path to check
# Returns: 1 if its a directory, otherwise 0
# Sideeffects: none
##########

  if {[file isdirectory $pathName]} {
    return 1
  } {
    catch "file type $pathName" fileType
    if {"$fileType" == "link"} {
      if {[catch "file readlink $pathName" linkName]} {
        return 0
      }
      catch "file type $linkName" fileType
      while {"$fileType" == "link"} {
        if {[catch "file readlink $linkName" linkName]} {
          return 0
        }
        catch "file type $linkName" fileType
      }
      return [file isdirectory $linkName]
    }
  }
  return 0
}


# Procedure: IsAFile
proc IsAFile { fileName} {
# xf ignore me 5
##########
# Procedure: IsAFile
# Description: check if filename is a file (including symbolic links)
# Arguments: fileName - the filename to check
# Returns: 1 if its a file, otherwise 0
# Sideeffects: none
##########

  if {[file isfile $fileName]} {
    return 1
  } {
    catch "file type $fileName" fileType
    if {"$fileType" == "link"} {
      if {[catch "file readlink $fileName" linkName]} {
        return 0
      }
      catch "file type $linkName" fileType
      while {"$fileType" == "link"} {
        if {[catch "file readlink $linkName" linkName]} {
          return 0
        }
        catch "file type $linkName" fileType
      }
      return [file isfile $linkName]
    }
  }
  return 0
}


# Procedure: IsASymlink
proc IsASymlink { fileName} {
# xf ignore me 5
##########
# Procedure: IsASymlink
# Description: check if filename is a symbolic link
# Arguments: fileName - the path/filename to check
# Returns: none
# Sideeffects: none
##########

  catch "file type $fileName" fileType
  if {"$fileType" == "link"} {
    return 1
  }
  return 0
}


# Procedure: OptionButtonGet
proc OptionButtonGet { widget} {

  if {"[winfo class $widget.value]" == "Label"} {
    return [lindex [$widget.value config -text] 4]
  } {
    if {"[winfo class $widget.value]" == "Entry"} {
      return [$widget.value get]
    }
  }
}


# Procedure: OptionButtonSet
proc OptionButtonSet { widget} {

  if {"[winfo class $widget.value]" == "Label"} {
    $widget.value config -text [lindex [$widget.menubutton2.m entryconfig [$widget.menubutton2.m index active] -label] 4]
  } {
    if {"[winfo class $widget.value]" == "Entry"} {
      $widget.value delete 0 end
      $widget.value insert 0 [lindex [$widget.menubutton2.m entryconfig [$widget.menubutton2.m index active] -label] 4]
    }
  }
}


# Procedure: YesNoBox
proc YesNoBox { {yesNoBoxMessage "Yes/no message"} {yesNoBoxGeometry "350x150"}} {
# xf ignore me 5
##########
# Procedure: YesNoBox
# Description: show yesno box
# Arguments: {yesNoBoxMessage} - the text to display
#            {yesNoBoxGeometry} - the geometry for the window
# Returns: none
# Sideeffects: none
##########
#
# global yesNoBox(activeBackground) - active background color
# global yesNoBox(activeForeground) - active foreground color
# global yesNoBox(anchor) - anchor for message box
# global yesNoBox(background) - background color
# global yesNoBox(font) - message font
# global yesNoBox(foreground) - foreground color
# global yesNoBox(justify) - justify for message box
# global yesNoBox(afterNo) - destroy yes-no box after n seconds.
#                            The no button is activated
# global yesNoBox(afterYes) - destroy yes-no box after n seconds.
#                             The yes button is activated

  global yesNoBox

  set tmpButtonOpt ""
  set tmpFrameOpt ""
  set tmpMessageOpt ""
  if {"$yesNoBox(activeBackground)" != ""} {
    append tmpButtonOpt "-activebackground \"$yesNoBox(activeBackground)\" "
  }
  if {"$yesNoBox(activeForeground)" != ""} {
    append tmpButtonOpt "-activeforeground \"$yesNoBox(activeForeground)\" "
  }
  if {"$yesNoBox(background)" != ""} {
    append tmpButtonOpt "-background \"$yesNoBox(background)\" "
    append tmpFrameOpt "-background \"$yesNoBox(background)\" "
    append tmpMessageOpt "-background \"$yesNoBox(background)\" "
  }
  if {"$yesNoBox(font)" != ""} {
    append tmpButtonOpt "-font \"$yesNoBox(font)\" "
    append tmpMessageOpt "-font \"$yesNoBox(font)\" "
  }
  if {"$yesNoBox(foreground)" != ""} {
    append tmpButtonOpt "-foreground \"$yesNoBox(foreground)\" "
    append tmpMessageOpt "-foreground \"$yesNoBox(foreground)\" "
  }

  # start build of toplevel
  if {"[info commands XFDestroy]" != ""} {
    catch {XFDestroy .yesNoBox}
  } {
    catch {destroy .yesNoBox}
  }
  toplevel .yesNoBox  -borderwidth 0
  catch ".yesNoBox config $tmpFrameOpt"
  if {[catch "wm geometry .yesNoBox $yesNoBoxGeometry"]} {
    wm geometry .yesNoBox 350x150
  }
  wm title .yesNoBox {Alert box}
  wm maxsize .yesNoBox 1000 1000
  wm minsize .yesNoBox 100 100
  # end build of toplevel

  message .yesNoBox.message1  -anchor "$yesNoBox(anchor)"  -justify "$yesNoBox(justify)"  -relief raised  -text "$yesNoBoxMessage"
  catch ".yesNoBox.message1 config $tmpMessageOpt"

  set xfTmpWidth  [string range $yesNoBoxGeometry 0 [expr [string first x $yesNoBoxGeometry]-1]]
  if {"$xfTmpWidth" != ""} {
    # set message size
    catch ".yesNoBox.message1 configure  -width [expr $xfTmpWidth-10]"
  } {
    .yesNoBox.message1 configure  -aspect 1500
  }

  frame .yesNoBox.frame1  -borderwidth 0  -relief raised
  catch ".yesNoBox.frame1 config $tmpFrameOpt"

  button .yesNoBox.frame1.button0  -text "Yes"  -command "
      global yesNoBox
      set yesNoBox(button) 1
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy .yesNoBox}
      } {
        catch {destroy .yesNoBox}
      }"
  catch ".yesNoBox.frame1.button0 config $tmpButtonOpt"

  button .yesNoBox.frame1.button1  -text "No"  -command "
      global yesNoBox
      set yesNoBox(button) 0
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy .yesNoBox}
      } {
        catch {destroy .yesNoBox}
      }"
  catch ".yesNoBox.frame1.button1 config $tmpButtonOpt"

  pack append .yesNoBox.frame1  .yesNoBox.frame1.button0 {left fillx expand}  .yesNoBox.frame1.button1 {left fillx expand}

  # packing
  pack append .yesNoBox  .yesNoBox.frame1 {bottom fill}  .yesNoBox.message1 {top fill expand}

  if {$yesNoBox(afterYes) != 0} {
    after [expr $yesNoBox(afterYes)*1000]  "catch \".yesNoBox.frame1.button0 invoke\""
  }
  if {$yesNoBox(afterNo) != 0} {
    after [expr $yesNoBox(afterNo)*1000]  "catch \".yesNoBox.frame1.button1 invoke\""
  }

  # wait for the box to be destroyed
  update idletask
  grab .yesNoBox
  tkwait window .yesNoBox

  return $yesNoBox(button)
}


# Procedure: apply
proc apply {} {

global attr mode apply_command

# call vl with format option, get owner, author, and mode
set vl_text [exec vl -format '\$__owner\$@\$__author\$_&&_\$__mode\$_&&_\$__locker\$&' "$attr(name)"]

regexp {^([^[]+).?([0-9.]*).?$} $attr(name) null prog_name prog_ver
set null {}
if [string compare $prog_ver $null] { set prog_ver "-bind $prog_ver" }

regexp {^'([^@]+)@([^@]+)@([^@]+)@[^&]+&&_.(.........)[^&]+&&_([^&]*)&}   $vl_text zz  new_owner new_host new_author new_mode new_locker

set vl_text "vadm "
set changed [expr {-1 * [string compare $attr(locker) $new_locker]}]

#convert mode bits to octal
set mode(new) "[expr {$mode(u,r)*4 +$mode(u,w)*2 +$mode(u,x)}][expr {$mode(g,r)*4 +$mode(g,w)*2 +$mode(g,x)}][expr {$mode(a,r)*4 +$mode(a,w)*2 +$mode(a,x)}]"

set vl_text "$vl_text -chmod $mode(new)"

if {$changed} {
   if {[string length $attr(locker)]} {
       set vl_text "$vl_text -lock -force -quiet"
   } {
       set vl_text "$vl_text -unlock"
   }
}

 
set vl_text "$vl_text $prog_ver $prog_name"

set apply_command $vl_text
}


# Procedure: auto_load_ouster_index
proc auto_load_ouster_index { fn} {
    global auto_index
    set dir [file dirname $fn]

    if [catch {set f [open $dir/tclIndex]}] {
        return
    }
    set error [catch {
        set id [gets $f]
        if {$id == "# Tcl autoload index file, version 2.0"} {
            eval [read $f]
        } elseif {$id == "# Tcl autoload index file: each line identifies a Tcl"} {
            while {[gets $f line] >= 0} {
                if {([string index $line 0] == "#")
                        || ([llength $line] != 2)} {
                    continue
                }
                set name [lindex $line 0]
                if {![info exists auto_index($name)]} {
                    set auto_index($name) "source $dir/[lindex $line 1]"
                }
            }
        } else {
            error "$dir/tclIndex isn't a proper Tcl index file"
        }
    } msg]
    if {$f != ""} {
        close $f
    }
    if $error {
        global errorInfo errorCode
        error $msg $errorInfo $errorCode
    }
}


# Procedure: fileselect.cancel.cmd
proc fileselect.cancel.cmd { w} {
# xf ignore me 6
    # puts stderr "Cancel"
    if {"[info commands XFDestroy]" != ""} {
        catch {XFDestroy $w}
    } {
        catch {destroy $w}
    }
}


# Procedure: fileselect.ok.cmd
proc fileselect.ok.cmd { w cmd} {
# xf ignore me 6
    global fileselect_entry fileselect_dirlabel fileselect_list 
    set selected [$fileselect_entry get]

    if {[file isdirectory $selected] != 0} {
	cd $selected
	set dir [exec pwd]
	eval $fileselect_dirlabel configure -text $dir
	eval $fileselect_entry delete 0 end
	eval $fileselect_list delete 0 end
	foreach i [exec ls -a $dir] {
	    if {[string compare $i "."] != 0} {
		eval $fileselect_list insert end $i
	    }
	}
	return
    }

    if {"[info commands XFDestroy]" != ""} {
        catch {XFDestroy $w}
    } {
        catch {destroy $w}
    }
    eval $cmd \"$selected\"
}


# Procedure: new_object_selected
proc new_object_selected {} {
global mode locker_bit attr 

#null out locker
set attr(locker) {}

# pull name out of selection
regexp { ([^ ]+)\}} [selection get] zz new_name
[SymbolicName obj_name] configure -text $new_name

# call vl with format option, get owner, author, and mode
set vl_text [exec vl -format '\$__owner\$@\$__author\$_&&_\$__mode\$_&&_\$__locker\$&' "$new_name"]

regexp {^([a-zA-Z0-9.,?!@#$%&_+=]*)} $new_name null attr(short_name)

regexp {^'([^@]+)@([^@]+)@([^@]+)@[^&]+&&_.(.........)[^&]+&&_([^&]*)&}   $vl_text zz  new_owner new_host new_author new_mode new_locker

set attr(name)   $new_name
set attr(owner)  $new_owner
set attr(host)   $new_host
set attr(author) $new_author
set attr(locker) $new_locker

[ SymbolicName obj_owner  ] delete 0 end
[ SymbolicName obj_owner  ] insert 0 $new_owner
[ SymbolicName obj_host   ] delete 0 end
[ SymbolicName obj_host   ] insert 0 $new_host
[ SymbolicName obj_author ] delete 0 end
[ SymbolicName obj_author ] insert 0 $new_author

#lock indicator
[ SymbolicName obj_locker ] configure -text $new_locker

if [eval {string length $new_locker}] {set locker_bit 1} {set locker_bit 0}


# mode bits
regexp {^(.)(.)(.)(.)(.)(.)(.)(.)(.)} $new_mode null   new_u_r new_u_w new_u_x   new_g_r new_g_w new_g_x   new_a_r new_a_w new_a_x

set mode(u,r) [expr {1 + [string compare $new_u_r r]}]
set mode(u,w) [expr {1 + [string compare $new_u_w w]}]
set mode(u,x) [expr {1 + [string compare $new_u_x x]}]

set mode(g,r) [expr {1 + [string compare $new_g_r r]}]
set mode(g,w) [expr {1 + [string compare $new_g_w w]}]
set mode(g,x) [expr {1 + [string compare $new_g_x x]}]

set mode(a,r) [expr {1 + [string compare $new_a_r r]}]
set mode(a,w) [expr {1 + [string compare $new_a_w w]}]
set mode(a,x) [expr {1 + [string compare $new_a_x x]}]
}


# Procedure: tclx_unknown2
proc tclx_unknown2 { cmd} {
    global tcl_interactive auto_noexec

    puts $cmd
    set name [lindex $cmd 0]

    if ![info exists auto_noexec] {
        if [auto_execok $name] {
            if {!$tcl_interactive || ([info level] > 2) ||
                [info script] != ""} {
                error "Auto execution of Unix commands only supported as interactive commands.\nUse \"exec\" to execute \"$name\""
            }
            uplevel 2 system [list $cmd]
            return
        }
    }

    if {!$tcl_interactive || ([info level] > 2) || [info script] != ""} {
        error "invalid command name \"$name\""
    }


    if {([info level] == 2) && ([info script] == "")} {
        if {$name == "!!"} {
            return [uplevel 2 {history redo}]
        }
        if [regexp {^!(.+)$} $name dummy event] {
            return [uplevel 2 [list history redo $event]]
        }
        if [regexp {^\^([^^]*)\^([^^]*)\^?$} $name dummy old new] {
            return [uplevel 2 [list history substitute $old $new]]
        }
        set cmds [info commands $name*]
        if {[llength $cmds] == 1} {
            return [uplevel 2 [lreplace $cmd 0 0 $cmds]]
        }
        if {[llength $cmds] != 0} {
            if {$name == ""} {
                return -code error "empty command name \"\""
            } else {
                return -code error  "ambiguous command name \"$name\": [lsort $cmds]"
            }
        }
    }
    error "invalid command name \"$name\""
}


# Procedure: tester
proc tester { cmnd} {
set p [eval open {|$cmnd} r+]
[SymbolicName ListBoxer] delete 0 end

while { [gets $p line] >= 0 } {
  [SymbolicName ListBoxer] insert end $line
}

close $p
}


# Internal procedures


# Procedure: Alias
if {"[info procs Alias]" == ""} {
proc Alias { args} {
# xf ignore me 7
##########
# Procedure: Alias
# Description: establish an alias for a procedure
# Arguments: args - no argument means that a list of all aliases
#                   is returned. Otherwise the first parameter is
#                   the alias name, and the second parameter is
#                   the procedure that is aliased.
# Returns: nothing, the command that is bound to the alias or a
#          list of all aliases - command pairs. 
# Sideeffects: internalAliasList is updated, and the alias
#              proc is inserted
##########
  global internalAliasList

  if {[llength $args] == 0} {
    return $internalAliasList
  } {
    if {[llength $args] == 1} {
      set xfTmpIndex [lsearch $internalAliasList "[lindex $args 0] *"]
      if {$xfTmpIndex != -1} {
        return [lindex [lindex $internalAliasList $xfTmpIndex] 1]
      }
    } {
      if {[llength $args] == 2} {
        eval "proc [lindex $args 0] {args} {#xf ignore me 4
return \[eval \"[lindex $args 1] \$args\"\]}"
        set xfTmpIndex [lsearch $internalAliasList "[lindex $args 0] *"]
        if {$xfTmpIndex != -1} {
          set internalAliasList [lreplace $internalAliasList $xfTmpIndex $xfTmpIndex "[lindex $args 0] [lindex $args 1]"]
        } {
          lappend internalAliasList "[lindex $args 0] [lindex $args 1]"
        }
      } {
        error "Alias: wrong number or args: $args"
      }
    }
  }
}
}


# Procedure: GetSelection
if {"[info procs GetSelection]" == ""} {
proc GetSelection {} {
# xf ignore me 7
##########
# Procedure: GetSelection
# Description: get current selection
# Arguments: none
# Returns: none
# Sideeffects: none
##########

  # the save way
  set xfSelection ""
  catch "selection get" xfSelection
  if {"$xfSelection" == "selection doesn't exist or form \"STRING\" not defined"} {
    return ""
  } {
    return $xfSelection
  }
}
}


# Procedure: MenuPopupAdd
if {"[info procs MenuPopupAdd]" == ""} {
proc MenuPopupAdd { xfW xfButton xfMenu {xfModifier ""} {xfCanvasTag ""}} {
# xf ignore me 7
# the popup menu handling is from (I already gave up with popup handling :-):
#
# Copyright 1991,1992 by James Noble.
# Everyone is granted permission to copy, modify and redistribute.
# This notice must be preserved on all copies or derivates.
#
##########
# Procedure: MenuPopupAdd
# Description: attach a popup menu to widget
# Arguments: xfW - the widget
#            xfButton - the button we use
#            xfMenu - the menu to attach
#            {xfModifier} - a optional modifier
#            {xfCanvasTag} - a canvas tagOrId
# Returns: none
# Sideeffects: none
##########
  global tk_popupPriv

  set tk_popupPriv($xfMenu,focus) ""
  set tk_popupPriv($xfMenu,grab) ""
  if {"$xfModifier" != ""} {
    set press "$xfModifier-"
    set motion "$xfModifier-"
    set release "Any-"
  } {
    set press ""
    set motion ""
    set release ""
  }

  bind $xfMenu "<${motion}B${xfButton}-Motion>"  "MenuPopupMotion $xfMenu %W %X %Y"
  bind $xfMenu "<${release}ButtonRelease-${xfButton}>"  "MenuPopupRelease $xfMenu %W"
  if {"$xfCanvasTag" == ""} {
    bind $xfW "<${press}ButtonPress-${xfButton}>"  "MenuPopupPost $xfMenu %X %Y"
    bind $xfW "<${release}ButtonRelease-${xfButton}>"  "MenuPopupRelease $xfMenu %W"
  } {
    $xfW bind $xfCanvasTag "<${press}ButtonPress-${xfButton}>"  "MenuPopupPost $xfMenu %X %Y"
    $xfW bind $xfCanvasTag "<${release}ButtonRelease-${xfButton}>"  "MenuPopupRelease $xfMenu %W"
  }
}
}


# Procedure: MenuPopupMotion
if {"[info procs MenuPopupMotion]" == ""} {
proc MenuPopupMotion { xfMenu xfW xfX xfY} {
# xf ignore me 7
##########
# Procedure: MenuPopupMotion
# Description: handle the popup menu motion
# Arguments: xfMenu - the topmost menu
#            xfW - the menu
#            xfX - the root x coordinate
#            xfY - the root x coordinate
# Returns: none
# Sideeffects: none
##########
  global tk_popupPriv

  if {"[info commands $xfW]" != "" && [winfo ismapped $xfW] &&
      "[winfo class $xfW]" == "Menu" &&
      [info exists tk_popupPriv($xfMenu,focus)] &&
      "$tk_popupPriv($xfMenu,focus)" != "" &&
      [info exists tk_popupPriv($xfMenu,grab)] &&
      "$tk_popupPriv($xfMenu,grab)" != ""} {
    set xfPopMinX [winfo rootx $xfW]
    set xfPopMaxX [expr $xfPopMinX+[winfo width $xfW]]
    if {$xfX >= $xfPopMinX && $xfX <= $xfPopMaxX} {
      $xfW activate @[expr $xfY-[winfo rooty $xfW]]
      if {![catch "$xfW entryconfig @[expr $xfY-[winfo rooty $xfW]] -menu" result]} {
        if {"[lindex $result 4]" != ""} {
          foreach binding [bind $xfMenu] {
            bind [lindex $result 4] $binding [bind $xfMenu $binding]
          }
        }
      }
    } {
      $xfW activate none
    }
  }
}
}


# Procedure: MenuPopupPost
if {"[info procs MenuPopupPost]" == ""} {
proc MenuPopupPost { xfMenu xfX xfY} {
# xf ignore me 7
##########
# Procedure: MenuPopupPost
# Description: post the popup menu
# Arguments: xfMenu - the menu
#            xfX - the root x coordinate
#            xfY - the root x coordinate
# Returns: none
# Sideeffects: none
##########
  global tk_popupPriv

  if {"[info commands $xfMenu]" != ""} {
    if {![info exists tk_popupPriv($xfMenu,focus)]} {
      set tk_popupPriv($xfMenu,focus) [focus]
    } {
      if {"$tk_popupPriv($xfMenu,focus)" == ""} {
        set tk_popupPriv($xfMenu,focus) [focus]
      }
    }
    set tk_popupPriv($xfMenu,grab) $xfMenu

    catch "$xfMenu activate none"
    catch "$xfMenu post $xfX $xfY"
    catch "focus $xfMenu"
    catch "grab -global $xfMenu"
  }
}
}


# Procedure: MenuPopupRelease
if {"[info procs MenuPopupRelease]" == ""} {
proc MenuPopupRelease { xfMenu xfW} {
# xf ignore me 7
##########
# Procedure: MenuPopupRelease
# Description: remove the popup menu
# Arguments: xfMenu - the topmost menu widget
#            xfW - the menu widget
# Returns: none
# Sideeffects: none
##########
  global tk_popupPriv
  global tkVersion

  if {"[info commands $xfW]" != "" && [winfo ismapped $xfW] &&
      "[winfo class $xfW]" == "Menu" &&
      [info exists tk_popupPriv($xfMenu,focus)] &&
      "$tk_popupPriv($xfMenu,focus)" != "" &&
      [info exists tk_popupPriv($xfMenu,grab)] &&
      "$tk_popupPriv($xfMenu,grab)" != ""} {
    if {$tkVersion >= 3.0} {
      catch "grab release $tk_popupPriv($xfMenu,grab)"
    } {
      catch "grab none"
    }
    catch "focus $tk_popupPriv($xfMenu,focus)"
    set tk_popupPriv($xfMenu,focus) ""
    set tk_popupPriv($xfMenu,grab) ""
    if {"[$xfW index active]" != "none"} {
      $xfW invoke active; catch "$xfMenu unpost"
    }
  }
  catch "$xfMenu unpost"
}
}


# Procedure: NoFunction
if {"[info procs NoFunction]" == ""} {
proc NoFunction { args} {
# xf ignore me 7
##########
# Procedure: NoFunction
# Description: do nothing
# Arguments: args - any kind of arguments
# Returns: none
# Sideeffects: none
##########
}
}


# Procedure: SN
if {"[info procs SN]" == ""} {
proc SN { {xfName ""}} {
# xf ignore me 7
##########
# Procedure: SN
# Description: map a symbolic name to the widget path
# Arguments: xfName
# Returns: the symbolic name
# Sideeffects: none
##########

  SymbolicName $xfName
}
}


# Procedure: SymbolicName
if {"[info procs SymbolicName]" == ""} {
proc SymbolicName { {xfName ""}} {
# xf ignore me 7
##########
# Procedure: SymbolicName
# Description: map a symbolic name to the widget path
# Arguments: xfName
# Returns: the symbolic name
# Sideeffects: none
##########

  global symbolicName

  if {"$xfName" != ""} {
    set xfArrayName ""
    append xfArrayName symbolicName ( $xfName )
    if {![catch "set \"$xfArrayName\"" xfValue]} {
      return $xfValue
    } {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "Unknown symbolic name:\n$xfName"
      } {
        puts stderr "XF error: unknown symbolic name:\n$xfName"
      }
    }
  }
  return ""
}
}


# Procedure: Unalias
if {"[info procs Unalias]" == ""} {
proc Unalias { aliasName} {
# xf ignore me 7
##########
# Procedure: Unalias
# Description: remove an alias for a procedure
# Arguments: aliasName - the alias name to remove
# Returns: none
# Sideeffects: internalAliasList is updated, and the alias
#              proc is removed
##########
  global internalAliasList

  set xfIndex [lsearch $internalAliasList "$aliasName *"]
  if {$xfIndex != -1} {
    rename $aliasName ""
    set internalAliasList [lreplace $internalAliasList $xfIndex $xfIndex]
  }
}
}



# application parsing procedure
proc XFLocalParseAppDefs {xfAppDefFile} {
  global xfAppDefaults

  # basically from: Michael Moore
  if {[file exists $xfAppDefFile] &&
      [file readable $xfAppDefFile] &&
      "[file type $xfAppDefFile]" == "link"} {
    catch "file type $xfAppDefFile" xfType
    while {"$xfType" == "link"} {
      if {[catch "file readlink $xfAppDefFile" xfAppDefFile]} {
        return
      }
      catch "file type $xfAppDefFile" xfType
    }
  }
  if {!("$xfAppDefFile" != "" &&
        [file exists $xfAppDefFile] &&
        [file readable $xfAppDefFile] &&
        "[file type $xfAppDefFile]" == "file")} {
    return
  }
  if {![catch "open $xfAppDefFile r" xfResult]} {
    set xfAppFileContents [read $xfResult]
    close $xfResult
    foreach line [split $xfAppFileContents "\n"] {
      # backup indicates how far to backup.  It applies to the
      # situation where a resource name ends in . and when it
      # ends in *.  In the second case you want to keep the *
      # in the widget name for pattern matching, but you want
      # to get rid of the . if it is the end of the name. 
      set backup -2  
      set line [string trim $line]
      if {[string index $line 0] == "#" || "$line" == ""} {
        # skip comments and empty lines
        continue
      }
      set list [split $line ":"]
      set resource [string trim [lindex $list 0]]
      set i [string last "." $resource]
      set j [string last "*" $resource]
      if {$j > $i} { 
        set i $j
        set backup -1
      }
      incr i
      set name [string range $resource $i end]
      incr i $backup
      set widname [string range $resource 0 $i]
      set value [string trim [lindex $list 1]]
      if {"$widname" != "" && "$widname" != "*"} {
        # insert the widget and resourcename to the application
        # defaults list.
        if {![info exists xfAppDefaults]} {
          set xfAppDefaults ""
        }
        lappend xfAppDefaults [list $widname [string tolower $name] $value]
      }
    }
  }
}

# application loading procedure
proc XFLocalLoadAppDefs {{xfClasses ""} {xfPriority "startupFile"} {xfAppDefFile ""}} {
  global env

  if {"$xfAppDefFile" == ""} {
    set xfFileList ""
    if {[info exists env(XUSERFILESEARCHPATH)]} {
      append xfFileList [split $env(XUSERFILESEARCHPATH) :]
    }
    if {[info exists env(XAPPLRESDIR)]} {
      append xfFileList [split $env(XAPPLRESDIR) :]
    }
    if {[info exists env(XFILESEARCHPATH)]} {
      append xfFileList [split $env(XFILESEARCHPATH) :]
    }
    append xfFileList " /usr/lib/X11/app-defaults"
    append xfFileList " /usr/X11/lib/X11/app-defaults"

    foreach xfCounter1 $xfClasses {
      foreach xfCounter2 $xfFileList {
        set xfPathName $xfCounter2
        if {[regsub -all "%N" "$xfPathName" "$xfCounter1" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%T" "$xfPathName" "app-defaults" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%S" "$xfPathName" "" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%C" "$xfPathName" "" xfResult]} {
          set xfPathName $xfResult
        }
        if {[file exists $xfPathName] &&
            [file readable $xfPathName] &&
            ("[file type $xfPathName]" == "file" ||
             "[file type $xfPathName]" == "link")} {
          catch "option readfile $xfPathName $xfPriority"
          if {"[info commands XFParseAppDefs]" != ""} {
            XFParseAppDefs $xfPathName
          } {
            if {"[info commands XFLocalParseAppDefs]" != ""} {
              XFLocalParseAppDefs $xfPathName
            }
          }
        } {
          if {[file exists $xfCounter2/$xfCounter1] &&
              [file readable $xfCounter2/$xfCounter1] &&
              ("[file type $xfCounter2/$xfCounter1]" == "file" ||
               "[file type $xfCounter2/$xfCounter1]" == "link")} {
            catch "option readfile $xfCounter2/$xfCounter1 $xfPriority"
            if {"[info commands XFParseAppDefs]" != ""} {
              XFParseAppDefs $xfCounter2/$xfCounter1
            } {
              if {"[info commands XFLocalParseAppDefs]" != ""} {
                XFLocalParseAppDefs $xfCounter2/$xfCounter1
              }
            }
          }
        }
      }
    }
  } {
    # load a specific application defaults file
    if {[file exists $xfAppDefFile] &&
        [file readable $xfAppDefFile] &&
        ("[file type $xfAppDefFile]" == "file" ||
         "[file type $xfAppDefFile]" == "link")} {
      catch "option readfile $xfAppDefFile $xfPriority"
      if {"[info commands XFParseAppDefs]" != ""} {
        XFParseAppDefs $xfAppDefFile
      } {
        if {"[info commands XFLocalParseAppDefs]" != ""} {
          XFLocalParseAppDefs $xfAppDefFile
        }
      }
    }
  }
}

# application setting procedure
proc XFLocalSetAppDefs {{xfWidgetPath "."}} {
  global xfAppDefaults

  if {![info exists xfAppDefaults]} {
    return
  }
  foreach xfCounter $xfAppDefaults {
    if {"$xfCounter" == ""} {
      break
    }
    set widname [lindex $xfCounter 0]
    if {[string match $widname ${xfWidgetPath}] ||
        [string match "${xfWidgetPath}*" $widname]} {
      set name [string tolower [lindex $xfCounter 1]]
      set value [lindex $xfCounter 2]
      # Now lets see how many tcl commands match the name
      # pattern specified.
      set widlist [info command $widname]
      if {"$widlist" != ""} {
        foreach widget $widlist {
          # make sure this command is a widget.
          if {![catch "winfo id $widget"] &&
              [string match "${xfWidgetPath}*" $widget]} {
            catch "$widget configure -$name $value" 
          }
        }
      }
    }
  }
}



# startup source
proc StartupSrc {args} {

}


# end source
proc EndSrc {} {
set VAR testing_testing
}

# prepare auto loading
global auto_path
global tk_library
global xfLoadPath
foreach xfElement [eval list [split $xfLoadPath :] $auto_path] {
  if {[file exists $xfElement/tclIndex]} {
    lappend auto_path $xfElement
  }
}
catch "unset auto_index"

catch "unset auto_oldpath"

catch "unset auto_execs"


# startup source
StartupSrc

# initialize global variables
proc InitGlobals {} {
  global { xxx}
  set { xxx} {1}
  global {$cwd}
  set {$cwd} {Current Directory:}
  global {VL}
  set {VL} {bongo.sh
bongo.tk
bongo.tk~
main.tcl
main.tcl~
tester[1.0]
tester1.c[1.0]
tester2.c}
  global {active_command}
  set {active_command} {1}
  global {alertBox}
  set {alertBox(activeBackground)} {}
  set {alertBox(activeForeground)} {}
  set {alertBox(after)} {0}
  set {alertBox(anchor)} {nw}
  set {alertBox(background)} {}
  set {alertBox(button)} {0}
  set {alertBox(font)} {}
  set {alertBox(foreground)} {}
  set {alertBox(justify)} {center}
  set {alertBox(toplevelName)} {.alertBox}
  global {apply_command}
  set {apply_command} {}
  global {attr}
  set {attr(author)} {madderra}
  set {attr(host)} {chernobyl}
  set {attr(locker)} {}
  set {attr(name)} {tester1.c}
  set {attr(owner)} {madderra}
  set {attr(short_name)} {tester1.c}
  global {checkbutton16}
  set {checkbutton16} {}
  global {checkbutton17}
  set {checkbutton17} {0}
  global {checkbutton18}
  set {checkbutton18} {0}
  global {checkbutton20}
  set {checkbutton20} {0}
  global {checkbutton21}
  set {checkbutton21} {0}
  global {checkbutton22}
  set {checkbutton22} {0}
  global {checkbutton24}
  set {checkbutton24} {1}
  global {checkbutton25}
  set {checkbutton25} {0}
  global {checkbutton4}
  set {checkbutton4} {0}
  global {checkbutton6}
  set {checkbutton6} {1}
  global {cmnd}
  set {cmnd} {ls -al}
  global {command_entry}
  set {command_entry} {}
  global {command_portion}
  set {command_portion} {vadm  -chmod 700 -bind 1.4}
  global {dir_selection}
  set {dir_selection} {/usr3/XIFCONFIG/bongo}
  global {fsBox}
  set {fsBox(activeBackground)} {}
  set {fsBox(activeForeground)} {}
  set {fsBox(all)} {0}
  set {fsBox(background)} {}
  set {fsBox(button)} {0}
  set {fsBox(extensions)} {0}
  set {fsBox(font)} {}
  set {fsBox(foreground)} {}
  set {fsBox(internalPath)} {/usr3/XIFCONFIG}
  set {fsBox(name)} {bongo}
  set {fsBox(path)} {/usr3/XIFCONFIG}
  set {fsBox(pattern)} {*}
  set {fsBox(scrollActiveForeground)} {}
  set {fsBox(scrollBackground)} {}
  set {fsBox(scrollForeground)} {}
  set {fsBox(scrollSide)} {left}
  set {fsBox(showPixmap)} {0}
  global {i}
  set {i} {tester2.c}
  global {inputBox}
  set {inputBox(.inputBox,inputMulti)} {}
  set {inputBox(.inputBox,inputOne)} {}
  set {inputBox(activeBackground)} {}
  set {inputBox(activeForeground)} {}
  set {inputBox(anchor)} {n}
  set {inputBox(background)} {}
  set {inputBox(erase)} {1}
  set {inputBox(font)} {}
  set {inputBox(foreground)} {}
  set {inputBox(justify)} {center}
  set {inputBox(scrollActiveForeground)} {}
  set {inputBox(scrollBackground)} {}
  set {inputBox(scrollForeground)} {}
  set {inputBox(scrollSide)} {left}
  set {inputBox(toplevelName)} {.inputBox}
  global {list_option}
  set {list_option} {radiobutton13}
  global {lock}
  set {lock} {0}
  global {locker_bit}
  set {locker_bit} {0}
  global {mode}
  set {mode(a,r)} {0}
  set {mode(a,w)} {0}
  set {mode(a,x)} {0}
  set {mode(g,r)} {0}
  set {mode(g,w)} {0}
  set {mode(g,x)} {0}
  set {mode(new)} {000}
  set {mode(u,r)} {0}
  set {mode(u,w)} {0}
  set {mode(u,x)} {0}
  global {name_portion}
  set {name_portion} {tester1.c}
  global {new_locker}
  set {new_locker} {1}
  global {null}
  set {null} {madderra }
  global {obj_locker}
  set {obj_locker} {---}
  global {prog}
  set {prog} {bob3~}
  global {short_name}
  set {short_name} {tester1.c}
  global {ver}
  set {ver} {}
  global {vl_command}
  set {vl_command} {sdfsdf sdf sdf sdf sdf sdf sdf sdf sdf sdf }
  global {vl_option_1}
  set {vl_option_1} {-al}
  global {vl_options}
  set {vl_options} {-locked}
  global {vl_options_1}
  set {vl_options_1} {vl -al}
  global {vl_text}
  set {vl_text} {dfgffffffffffffffffffffffffffffffdfgdsfgdfgdfgdfgdfg}
  global {wdir}
  set {wdir} {}
  global {whoami}
  set {whoami} {madderra}
  global {working_dir}
  set {working_dir} {     Select A Directory First}
  global {x}
  set {x} {0}
  global {y}
  set {y} {{tester[1.0]}}
  global {yesNoBox}
  set {yesNoBox(activeBackground)} {}
  set {yesNoBox(activeForeground)} {}
  set {yesNoBox(afterNo)} {0}
  set {yesNoBox(afterYes)} {0}
  set {yesNoBox(anchor)} {n}
  set {yesNoBox(background)} {}
  set {yesNoBox(button)} {1}
  set {yesNoBox(font)} {*times-bold-r-normal*24*}
  set {yesNoBox(foreground)} {}
  set {yesNoBox(justify)} {center}
  global {z}
  set {z} {bongo.sh}
  global {zz}
  set {zz} { bongo.sh}

  # please don't modify the following
  # variables. They are needed by xf.
  global {autoLoadList}
  set {autoLoadList(bongo)} {0}
  set {autoLoadList(main.tcl)} {0}
  global {internalAliasList}
  set {internalAliasList} {}
  global {moduleList}
  set {moduleList(bongo)} {}
  global {preloadList}
  set {preloadList(xfInternal)} {}
  global {symbolicName}
  set {symbolicName(ListBox1)} {.frame1.listbox11}
  set {symbolicName(ListBoxer)} {.frame1.frame.listbox1}
  set {symbolicName(apply_button)} {.frame1.frame2.button0}
  set {symbolicName(obj_author)} {.frame1.frame0.frame1.frame16.value}
  set {symbolicName(obj_host)} {.frame1.frame0.frame1.frame15.value}
  set {symbolicName(obj_locker)} {.frame1.frame0.frame2.frame7.label11}
  set {symbolicName(obj_name)} {.frame1.frame0.frame1.frame.label1}
  set {symbolicName(obj_owner)} {.frame1.frame0.frame1.frame0.value}
  set {symbolicName(root)} {.}
  set {symbolicName(vl_auther)} {.frame1.frame0.frame1.frame4.frame8.entry5}
  set {symbolicName(vl_locker)} {.frame1.frame0.frame1.frame4.frame9.entry5}
  set {symbolicName(vl_mode)} {.frame1.frame0.frame1.frame4.frame11.entry5}
  set {symbolicName(vl_name)} {.frame1.frame0.frame1.frame4.frame.entry5}
  set {symbolicName(vl_owner)} {.frame1.frame0.frame1.frame4.frame7.entry5}
  set {symbolicName(vl_size)} {.frame1.frame0.frame1.frame4.frame10.entry5}
  set {symbolicName(vl_status)} {.frame1.frame0.frame1.frame4.frame6.entry5}
  set {symbolicName(working_dir)} {.frame4.frame6.entry5}
  global {xfWmSetPosition}
  set {xfWmSetPosition} {}
  global {xfWmSetSize}
  set {xfWmSetSize} {}
  global {xfAppDefToplevels}
  set {xfAppDefToplevels} {}
}

# initialize global variables
InitGlobals

# display/remove toplevel windows.
ShowWindow.

# load default bindings.
if {[info exists env(XF_BIND_FILE)] &&
    "[info procs XFShowHelp]" == ""} {
  source $env(XF_BIND_FILE)
}

# parse and apply application defaults.
XFLocalLoadAppDefs Bongo
XFLocalSetAppDefs

# end source
EndSrc

# eof
#

